unit Score2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, DBGrids, StdCtrls, constDef, db, Buttons, ComCtrls, ExtCtrls,
  Menus;

type
  TSF2 = class(TForm)
    DBGrid1: TDBGrid;
    CheckBox1: TCheckBox;
    Label1: TLabel;
    RowCount: TLabel;
    BackBtn: TBitBtn;
    WrongAnswers: TCheckBox;
    RightAnswers: TCheckBox;
    StatusBar1: TStatusBar;
    CurentUserOnly: TCheckBox;
    PopupMenu1: TPopupMenu;
    open1: TMenuItem;
    procedure DBGrid1TitleClick(Column: TColumn);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure DBGrid1DblClick(Sender: TObject);
    procedure BackBtnClick(Sender: TObject);
    procedure WrongAnswersClick(Sender: TObject);
    procedure RightAnswersClick(Sender: TObject);
    procedure DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure FormHide(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CurentUserOnlyClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    row:	word;
    noSort:	Boolean;	// Set to true when showing the detail
    group:	Integer;
    function CreateSQL(row:word; f:string): String;
    procedure UpdateSql();

    { Private declarations }

  public
    logGroupId:	Integer;
    { Public declarations }
  end;

var
  SF2: TSF2;

implementation
uses _ScoreUtils2, _String, _dos;
{$R *.DFM}

procedure updateDB(row: Word; f: String);
var
  sql:	String;
  col:	TColumn;
begin
//   if (not su.Visible) or (su.SQL.Lines[1] = 'No SQL') then UpDateSQL;
  sql := SF2.CreateSQL(row, f);
  su.ConectDB;
  su.IBDataSet1.Active := False;
  su.IBDataSet1.SelectSQL.Text := sql;
  su.IBDataSet1.Active := True;
  su.IBDataSet1.First;
//  su.IBDataSet1.Next;
  su.IBDataSet1.Last;
  su.IBDataSet1.First;
    begin
      sf2.DBGrid1.Columns.Clear;
      col := sf2.DBGrid1.Columns.Add;
      col.Width := 200;
      col.FieldName := 'NAME';
      col := sf2.DBGrid1.Columns.Add;
//      col.Width := 150;
      col.FieldName := 'Percent1';
      col.Title.Caption := 'Percent';
      col := sf2.DBGrid1.Columns.Add;
//      col.Width := 150;
      col.FieldName := 'Ratio';
      col := sf2.DBGrid1.Columns.Add;
//      col.Width := 55;
      col.FieldName := 'Date1';
      col.Title.Caption := 'Date';
      col := sf2.DBGrid1.Columns.Add;
//      col.Width := 70;
      col.FieldName := 'Time1';
      col.Title.Caption := 'Time';
      col := sf2.DBGrid1.Columns.Add;
//      col.Width := 200;
      col.FieldName := 'Max_help';
      col.Title.Caption := 'Max help';
      col := sf2.DBGrid1.Columns.Add;
//      col.Width := 200;
      col.FieldName := 'help_total';
      col.Title.Caption := 'Help total';
      if not sf2.CheckBox1.Checked then
	begin
	  col := sf2.DBGrid1.Columns.Add;
	  col.Width := 200;
	  col.FieldName := 'file1';
	  col.Title.Caption := 'File';
	end;

    end;
  sf2.RowCount.Caption := IntToStr( sf2.DBGrid1.DataSource.DataSet.RecordCount);
end;

function TSF2.CreateSQL(row:word; f:string): String;
var
  sql:	String;
begin
  sql := 'select name, percent1, ratio, date1, time1, max_help, '+
	'help_total, log_group ';
  if  sf2.CheckBox1.Checked then
  begin
    if sf2.CurentUserOnly.Checked then sql := sql + ' from score_tab'+
	 ' where UPPER(file1) = '#39+SUpCase(f)+#39' and name = '#39+pas.User+#39
    else sql := sql + ' from score_tab where UPPER(file1) = '#39+SUpCase(f)+#39
  end
  else begin
    if sf2.CurentUserOnly.Checked then sql := sql +
    ' , file1 from score_tab where name = '#39+pas.User+#39' '
    else sql := sql + ' , file1 from score_tab ';
  end;

  if row = 0 then
     sql := sql + ' order by name, percent1 desc,'+
	' sort_date desc, time1 desc'
  else if row = 1 then
     sql :=  sql + ' order by percent1 desc,'+
	' sort_date desc, time1 desc'
  else if row = 3 then
     sql :=  sql + ' order by sort_date desc, time1 desc';
  result := sql;
end;

procedure TSF2.DBGrid1TitleClick(Column: TColumn);
begin
  if NoSort then exit;
  if (column.Index in [0,1,3]) and (row <> column.Index) then
    begin
      row := column.Index;
      UpdateDB(row, SubDir+FileName(CurrentFile)+'.sco');
    end;
end;

procedure TSF2.CheckBox1Click(Sender: TObject);
begin
  UpdateDB(row, SubDir+FileName(CurrentFile)+'.sco');
end;

procedure TSF2.FormShow(Sender: TObject);
begin
  WrongAnswers.Visible := false;
  RightAnswers.Visible := false;
  CheckBox1.Visible := True;
  CurentUserOnly.Visible := True;
  noSort := False;
  row := 1;
  UpdateDB(row, SubDir+FileName(CurrentFile)+'.sco');
end;

procedure TSF2.UpdateSql();
var
  sql: String;
begin
  sql := 'select Name, Word, Answer, Help_count from log where log_group = '+
	 IntToStr(group);
  if WrongAnswers.Checked and RightAnswers.Checked then
    begin
    end
  else if WrongAnswers.Checked then sql := sql + ' and Answer is not null'
  else sql := sql + ' and Answer is null';
  su.ConectDB;
  su.IBDataSet1.Active := False;
  su.IBDataSet1.SelectSQL.Text := sql;
  su.IBDataSet1.Active := True;
  su.IBDataSet1.Last;
  su.IBDataSet1.First;
  RowCount.Caption := IntToStr( DBGrid1.DataSource.DataSet.RecordCount);
end;

procedure TSF2.DBGrid1DblClick(Sender: TObject);
var
  x:	Integer;
  name, name2:	String;
begin
  if NoSort then Exit;
  PopupMenu1.AutoPopup := false;
  name2 := SUpCase(self.DBGrid1.DataSource.DataSet.FieldByName('Name').AsString) ;
  name := SUpCase(pas.User);
  if (name <> name2) and (pas.PasLevel < lookOtherUsersPasLev)
    then begin
      MessageDlg('Access denied.'#10 +
		  'You were''t going to look at someone else''s mistakes and then tease then were you!!!', mtWarning, [mbOK], 0);
      exit;
    end;
  DBGrid1.Hint := 'The list of words you got wrong/right for the row double clicked.';
  CheckBox1.Visible := False;
  CurentUserOnly.Visible := False;
  WrongAnswers.Visible := true;
  RightAnswers.Visible := true;
  NoSort := True;
  group := self.DBGrid1.DataSource.DataSet.FieldByName('LOG_GROUP').AsInteger ;
  UpdateSQL;
  DBGrid1.Columns.RebuildColumns;
  for x := 0 to DBGrid1.Columns.Count - 1 do
    if DBGrid1.Columns[x].Width > 180
    then DBGrid1.Columns[x].Width := 180;
  DBGrid1.Columns[3].Title.Caption := 'Help';
end;

procedure TSF2.BackBtnClick(Sender: TObject);
begin
//  backBtn.Visible := False;
  if not noSort then self.ModalResult := mrOk
  else
    begin
      PopupMenu1.AutoPopup := True;
      WrongAnswers.Visible := false;
      RightAnswers.Visible := false;
      NoSort := False;
      CheckBox1.Visible := True;
      CurentUserOnly.Visible := True;
      DBGrid1.Hint := 'Double click a row to see the words you got wrong/right.';
      UpdateDB(row, SubDir+FileName(CurrentFile)+'.sco');
    end;
end;

procedure TSF2.WrongAnswersClick(Sender: TObject);
begin
  if not WrongAnswers.Checked and not RightAnswers.Checked then
  RightAnswers.Checked := True;
  UpdateSQL;
end;

procedure TSF2.RightAnswersClick(Sender: TObject);
begin
  if not WrongAnswers.Checked and not RightAnswers.Checked then
  WrongAnswers.Checked := True;
  UpdateSQL;
end;

procedure TSF2.DBGrid1DrawColumnCell(Sender: TObject; const Rect: TRect;
  DataCol: Integer; Column: TColumn; State: TGridDrawState);
var
  r2: TRect;
  mr: Word;
begin
  if (logGroupId = -1) or noSort then exit;
  if self.DBGrid1.DataSource.DataSet.FieldByName('log_Group').AsInteger  = logGroupId then
    begin
      DBGrid1.Canvas.Font.Color := clHighlightText;
      DBGrid1.Canvas.Brush.Color := clHighlight;
      DBGrid1.Canvas.Pen.Width := 2;
      mr := DBGrid1.Canvas.Pen.Width div 2 - 1;
      r2.left := rect.left + mr;
      r2.Top := rect.top + mr;
      r2.Right := rect.right - mr;
      r2.Bottom := rect.bottom - mr;
      DBGrid1.Canvas.Brush.Style := bsClear;
      DBGrid1.Canvas.Pen.Color := clRed;
      DBGrid1.Canvas.Rectangle(R2);
    end;

end;

procedure TSF2.FormHide(Sender: TObject);
begin
  logGroupId := -1;
end;

procedure TSF2.FormCreate(Sender: TObject);
begin
  logGroupId := -1;
end;

procedure TSF2.CurentUserOnlyClick(Sender: TObject);
begin
  if self.CurentUserOnly.Checked then
  row := 3;
  UpdateDB(row, SubDir+FileName(CurrentFile)+'.sco');
end;

procedure TSF2.FormResize(Sender: TObject);
begin
//  DBGrid1.Left := 0;
//  DBGrid1.Width := Width - 8;
  DBGrid1.Top := 38;
  DBGrid1.Height := Height - 82;
end;

end.
