unit _Edit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls, _Buffers, Buttons;

type
  TEditSpl = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Save1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    DeleteLinefeeds1: TMenuItem;
    RichEdit1: TRichEdit;
    Print1: TMenuItem;
    viewcompiled1: TMenuItem;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Save1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure DeleteLinefeeds1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure viewcompiled1Click(Sender: TObject);
  private
    { Private declarations }
    editFile:string;
    Procedure ViewBuf1(buf:BufferO;readOnly:Boolean);
  public
    Procedure edit(f:string);
    Procedure ViewBuf(buf:BufferO);
    procedure View(f:string);
    Procedure Save(s:string = '');
    { Public declarations }
  end;

var
  EditSpl: TEditSpl;

implementation
uses
  ConstDef, _PasWord, _dos, _String, _ViewConpiled;

{$R *.DFM}

procedure TEditSpl.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  save;
  RichEdit1.Lines.Clear;
end;

Procedure TEditSpl.edit(f:string);
var
  buf:BufferO;
  owner : String;
begin
  buf := BufferO.Create;
  editFile := f;
   if test(FilePath(f)+fileName(f)+'.usr') then
     LoadBuffer(buf,FilePath(f)+fileName(f)+'.usr');
   if buf.Len >=1 then owner := buf.Get(1)
   else owner := '';
   if (not pas.TestPasLevel(IntToStr(pas.LookAtPasLev)))
     and ('"'+SUpCase(pas.User)+'"' <> SUpCase(owner) ) then
    begin
      MessageDlg('Access denied',  mtWarning, [mbOK],0);
    end
   else
    begin
      buf.Clr;
      LoadBuffer(buf, editFile);
      ViewBuf1(buf, False);
    end;
  buf.Destroy;
end;

Procedure TEditSpl.ViewBuf(buf:BufferO);
begin
  ViewBuf1(buf,True);
end;

Procedure TEditSpl.ViewBuf1(buf:BufferO; ReadOnly:Boolean);
var
  x : Integer;
  t:string;
begin
  RichEdit1.Lines.Clear;
   for x := 1 to buf.len do
    begin
      t := buf.Get(x);
      RichEdit1.Lines.Add(t);
    end;
  RichEdit1.Modified := False;
  if readOnly = true then
    begin
      EditSpl.RichEdit1.ReadOnly := True;
      EditSpl.Save1.Enabled := False;
    end
  else
    begin
      EditSpl.RichEdit1.ReadOnly := False;
      EditSpl.Save1.Enabled := True;
    end;
  EditSpl.ShowModal;
end;

Procedure TEditSpl.View(f:string);
var
  buf:BufferO;
begin
  buf := BufferO.Create;
  editFile := f;
  LoadBuffer(buf, editFile);
  ViewBuf1(buf, True);
  buf.Destroy;
end;

procedure TEditSpl.Save1Click(Sender: TObject);
begin
  save;
end;

Procedure TEditSpl.Save(s:string = '');
var
  buf:BufferO;
  x:word;
  f:string;
begin
   if s = '' then f := editFile
   else f := s;
   if (s <> '') or ((RichEdit1.Modified) and (f <> '')) then
   if (s <> '') or (MessageDlg('Save changes', mtConfirmation, [mbYes, mbNo],0) = mrYes) then
    begin
      buf := BufferO.Create;
       for x := 1 to RichEdit1.Lines.Count do buf.Add(RichEdit1.Lines[x-1]);
      SaveBuffer(buf, f);
      RichEdit1.Modified := False;
      buf.Destroy;
    end;
end;

procedure TEditSpl.Exit1Click(Sender: TObject);
begin
  EditSpl.ModalResult := mrOk;
end;

procedure TEditSpl.DeleteLinefeeds1Click(Sender: TObject);
var
  s:	String;
  x:	Word;
begin
   for x := 0 to RichEdit1.Lines.Count - 1 do
    begin
      s := s + RichEdit1.Lines.Strings[x] + ' ';
    end;
  s := DelTrailing(s,' ');
  RichEdit1.Text := s;
  RichEdit1.Modified := False;
  EditSpl.RichEdit1.ReadOnly := True;
  EditSpl.Save1.Enabled := false;
end;

procedure TEditSpl.Print1Click(Sender: TObject);
begin
  RichEdit1.Print(CurrentFile);
end;

procedure TEditSpl.viewcompiled1Click(Sender: TObject);
begin
  save(ProgramDir+'compile temp.spl');
  CompiledView.View(ProgramDir + 'compile temp.spl');
end;

end.
