{$A+,B-,D-,E+,F+,G-,I+,L+,N-,O-,R+,S+,V+,X-}
unit _keyb;

interface


Type
  key = string[2];
  ka = Record
         scan : Word;
         k    : String[2];
       end;
  KeyString = Record
		length : Word;
		s	: Array[1..255] of Word;
	      end;

Const
  LastKey     	: String[2] = '';
  EatKey        : Boolean   = False;

{$I I_Key1}

{$I I_Key2}		{ Extended key scan codes }
{$I I_Key4}		{BIOS keystroke codes, hexadecimal

{ Keyboard state and shift masks }

  kbRightShift  = $0001;
  kbLeftShift   = $0002;
  kbCtrlShift   = $0004;
  kbAltShift    = $0008;
  kbScrollState = $0010;
  kbNumState    = $0020;
  kbCapsState   = $0040;
  kbInsState    = $0080;

  SL1 = '';

type

  S78 = String[78];
Var
  KeyProc1 : Procedure;
  KeyProc2 : Procedure;



Function KeyCode:Key;					{Assembler;}
Function NextKeyCode:Key;				{Assembler;}
Function KeyLoop : Key;
Function KeyPressed : Boolean;				{Assembler;}
Function NextKey : Word;				{Assembler;}
Function ReadKey : Char;

Procedure Flush;					{Assembler;}
Function GetKey : Word;					{Assembler;}
Procedure NextCommand(Command : String);

Procedure OffKey(Var p);
Procedure OnKey(var p; s : KeyString);

procedure Nothing;
{******************************Begin Key port****************************}
Type
  JKeyElt = record
	      KeyCode : Byte;
		case Byte of
		  1 : (ShiftByte1, ShiftByte2	: Byte);
		  2 : (ShiftWord		: Word);
	    end;
Const
  JKeyBufSize	= 20;
  JKeyBOffset	: word = 0;
  JKeyBSeg	: word = 0;
  JK00		: byte = 0;
  JK05		: Word = 0;
  JK07		: Word = 0;
  JK09		: Word = 0;
  JK11		: Word = 0;
  JK13		: Word = 0;
var
  JK15		: Array[1..JKeyBufSize] of JKeyElt ;
Type
  JKeyBO = Object
	     Procedure Init;
	     Procedure Done;
	     Procedure JReadKey(var JKey : JKeyElt); {Assembler;}
	   Private
	     JKeyBSegOld		: Word;
	     JKeyBOffsetOld		: Word;
	     sPos			: Byte;
	     JKbdIntVec			: Procedure;
	     JKeyBufSeg			: Word;
	     JKeyBufBeginOffset		: Word;
	     JKeyBufEndOffset		: Word;
	     JKeyCodeBeginOffset	: Word;
	     JKeyCodeEndOffset		: Word;
	     JKeyBuf			: Array[1..JKeyBufSize] of JKeyElt;
	   end;
{******************************End Key port****************************}


implementation

Procedure JKeyB;  				Forward;
{Procedure TestKey; Interrupt;				Forward;}

Type
  ListP = ^List;
  List = Record {9}
	   n : ListP;
	   p : Pointer;
	   s : KeyString;
	 end;

Const
  start : ListP = Nil;

var
  i:byte;
  HeadPointer	: Byte Absolute { $0040:$001A;}$41a;
  TailPointer	: Byte Absolute { $0040:$001C;} $041c;
  KbdIntVec	: Procedure;

Function KeyLoop : Key;
Var
  k : Key;
Label Start;
begin
  Start:
  EatKey := False;
  k := '';
    Repeat
       if KeyPressed then
        begin
	  k := KeyCode;
          LastKey := k;
          KeyProc1;
	end
       else KeyProc2;
       if EatKey then Goto Start;
    Until(k <> '');
  KeyLoop := k;
  LastKey := k;
end;

Function NextKeyCode:Key;	Assembler;
asm
  push	bp
  mov	bp, sp
  call	NextKey				{a := GetKey;}
  les	di, @Result
  cmp	al, 224                         { if (Lo(a) = 224) or (Lo(a) = 0) then}
  je	@Convert
  cmp	al, 0
  je	@Convert
  mov	[es:di], 1.Byte(0)			{ else keyCode := Chr(Lo(a));}
  mov	[es:di + 1], al
  jmp	@end
@Convert:				{  begin}
  mov	[es:di + 1], 0.Byte(0)			{    keyCode[0] := Chr(2);}
  mov	cl, 2				{    keyCode[1] := Chr(0);}
  mov	[es:di], cl			{    keyCode[2] := Chr(Hi(a));}
  mov	[es:di + 2], ah			{  end;}
@end:
  pop	bp
end;

Function KeyCode:Key;	Assembler;
asm
  push	bp
  mov	bp, sp
  call	GetKey				{a := GetKey;}
  les	di, @Result
  cmp	al, 224                         { if (Lo(a) = 224) or (Lo(a) = 0) then}
  je	@Convert
  cmp	al, 0
  je	@Convert
  mov	[es:di], 1.Byte(0)			{ else keyCode := Chr(Lo(a));}
  mov	[es:di + 1], al
  jmp	@end
@Convert:				{  begin}
  mov	[es:di + 1], 0.Byte(0)			{    keyCode[0] := Chr(2);}
  mov	cl, 2				{    keyCode[1] := Chr(0);}
  mov	[es:di], cl			{    keyCode[2] := Chr(Hi(a));}
  mov	[es:di + 2], ah			{  end;}
@end:
  pop	bp
end;

Function ReadKey : Char;
var
  r : Registers;
begin
  r.ah := $07;
  Intr($21,r);
  ReadKey := Char(r.al);
end;

Procedure NextCommand(Command : String);
Type
  KeyArray = array[$1E..$3D] of Byte;

var
  i, CmdSize       : Byte;
  HeadPointer      : Byte Absolute $0040:$001A;
  TailPointer      : Byte Absolute $0040:$001C;
  KeyBuffer        : ^KeyArray;
Begin
  KeyBuffer := Ptr($0040, $001E);
  TailPointer := $1E;
  HeadPointer := TailPointer;
  CmdSize := Length(Command);
   for i := 1 to CmdSize do
    begin
      KeyBuffer^[TailPointer] := Ord(Command[i]);
      KeyBuffer^[TailPointer + 1] := 0;
      TailPointer := TailPointer + 2;
    end;
  KeyBuffer^[TailPointer] := 13;
  KeyBuffer^[TailPointer + 1] := 28;
end;
  
Procedure Flush; Assembler;
asm
  xor	ax, ax			{HeadPointer := TailPointer;}
  mov	es, ax
  mov	ax, [es:$041A]
  mov	[es:$041C], ax
end;
{$F+}
Procedure Nothing; Assembler;
asm
end;


Procedure TestKey; Interrupt;
Const
  p : ListP = nil;
  c : Word = 0;
var
  proc	: Procedure;
begin
  c := NextKey;
  KbdIntVec;
  p := start;
   While p^.n <> nil do
    begin
	asm
	  les	di, p + 10
	  mov	cx, [es:di - 2]
	  mov	ax, c
	  cld
	  repne	scasw
	  jne	@NotFound
	  les	di, p + 4
	  mov	bx, [es:di]
	  mov	proc.word(0), bx
	  mov	bx, [es:di + 2]
	  mov	proc.Word(2), bx
	  call	proc
	@NotFound:
	end;
      p := p^.n
    end;
end;
{$F-}
Procedure OffKey(Var p);
var
  p2, p3 : ListP;
begin
  p2 := start;
  p3 := start;
   while p2 <> nil do
    begin
       if Listp(p2^.p) = ListP(p) then
	begin
	   if p2 = Start then
	    begin
	      start := p2^.n;
	      FreeMem(p2, p2^.s.length + 10);
	      p2 := start;
	    end
	    else begin
	      p3^.n := p2^.n;
	      FreeMem(p2, p2^.s.length + 10);
	      p2 := p3^.n;
	    end;
	end
	else begin
	  p3 := p2;
	  p2 := p2^.n;
	end;
    end;
end;

Procedure OnKey(var p; s : KeyString);
Var
  p1, p2 : ListP;
begin
  GetMem(p1, 10 + (s.length * 2));
  p1^.n := nil;
asm
  mov	ax, p.Word(0)		{p1^.p := p;}
  mov	bx, p.Word(2)
  les	di, p1
  mov	[es:di + 4], ax
  mov	[es:di + 6], bx
end;
   if start = Nil then
    begin
      start := p1;
      GetIntVec($9,@KbdIntVec);
{      SetIntVec($9,Addr(TestKey));}
    end
    else begin
      p2 := start;
       While p2^.n <> nil do p2 := p2^.n;
      p2^.n := p1;
    end;
end;

Function GetKey : Word; Assembler;
asm
  mov	ax, $40
  mov	es, ax
  mov	di, $1A
  mov	si, di
@l1:
  mov	ax, [es:si]
  mov	bx, [es:si + 2]
  cmp	ax, bx
  je	@l1
  mov	si, ax
  mov	ax, [es:si]
  inc	[es:di].word
  inc	[es:di].word
  mov	cx, [es:$82]
  sub	cx, 2
  cmp	[es:di].word, cx
  jna	@s1
  mov	bx, [es:$80]
  mov	[es:di], bx
@s1:
end;

Function KeyPressed : Boolean; Assembler;
asm
  mov	ax, $40
  mov	es, ax
  mov	ax, [es:$1A]
  cmp	ax, [es:$1C]
  mov	ax, 0
  je	@s1
  mov	ax, 1
@s1:
end;

Function NextKey : Word; Assembler;
asm
  mov	ax, $40
  mov	es, ax
  mov	di, $1A
  mov	si, di
@l1:
  mov	ax, [es:si]
  mov	bx, [es:si + 2]
  cmp	ax, bx
  je	@l1
  mov	si, ax
  mov	ax, [es:si]
end;

{******************************Begin Key port****************************}
Procedure JKeyBO.Init;
begin
  sPos			:= JKeyBufSize * 3;
  JKeyBufSeg		:= Seg(JKeyBuf);
  JKeyBufBeginOffset	:= Ofs(JKeyBuf);
  JKeyBufEndOffset	:= Ofs(JKeyBuf) + ((JKeyBufSize - 1) * 3);
  JKeyCodeBeginOffset	:= JKeyBufBeginOffset;
  JKeyCodeEndOffset	:= JKeyBufBeginOffset;
  JKeyBOffsetOld := _KeyB.JKeyBOffset;
  _KeyB.JKeyBOffset := Ofs(sPos);
  JKeyBSegOld := _KeyB.JKeyBSeg;
  _KeyB.JKeyBSeg := Seg(sPos);
  GetIntVec($9,@JKbdIntVec);
  SetIntVec($9,Addr(JKeyB));
end;

Procedure JKeyBO.Done;
begin
  _KeyB.JKeyBOffset := JKeyBOffsetOld;
  _KeyB.JKeyBSeg := JKeyBSegOld;
  SetIntVec($9,@JKbdIntVec);
end;

{$F+}
Procedure JKeyB; Assembler;
asm
	push	ax
	push	es
	push	di
	push	dx
	mov	ax, JKeyBOffset
	mov	es, ax
	mov	di, JKeyBSeg
	mov	al, [es:di]
	mov	JK00, al
	mov	ax, [es:di + 05]
	mov	JK05, ax
	mov	ax, [es:di + 07]
	mov	JK07, ax
	mov	ax, [es:di + 09]
	mov	JK09, ax
	mov	ax, [es:di + 11]
	mov	JK11, ax
	mov	ax, [es:di + 13]
	mov	JK13, ax
	mov	ax, JK05 {JKeyBufSeg}
	mov	es, ax
        in	al, 60h
	mov	di, JK13 {JKeyCodeEndOffset}
	mov	[es:di], al {l}
	mov	dx, es
	xor	ax, ax
	mov	es, ax
	mov	ax, [es:$417]
	mov	es, dx
	mov	[es:di + 1], ax
	add	JK13, 3		{[JKeyCodeEndOffset.word], 3}
	mov	di, JK09	{JKeyBufEndOffset}
	cmp	di, JK13	{JKeyCodeEndOffset}
	jae	@s1
	mov	ax, JK07	{JKeyBufBeginOffset}
	mov	JK13, ax {JKeyCodeEndOffset}
@s1:	mov	ax, JK11 {JKeyCodeBeginOffset}
	cmp	ax, JK13 {JKeyCodeEndOffset}
	jne	@s2
	add	JK11, 3 {JKeyCodeBeginOffset}
	mov	di, JK09 {JKeyBufEndOffset}
	cmp	di, JK11 {JKeyCodeBeginOffset}
	jae	@s2
	mov	ax, JK07 {JKeyBufBeginOffset}
	mov	JK11, ax {JKeyCodeBeginOffset}

@s2:    mov	al, JK00
	mov	[es: di], al
	mov	ax, JK05
	mov	[es: di + 05], ax
	mov	ax, JK07
	mov	[es: di + 07], ax
	mov	ax, JK09
	mov	[es: di + 09], ax
	mov	ax, JK11
	mov	[es: di + 11], ax
	mov	ax, JK13
	mov	[es: di + 13], ax
{$IFDEF DEBUG}
	pushf
	cli
	call	JKbdIntVec;
{$ENDIF}
	pop	dx
	pop	di
	pop	es
	pop	ax
	iret
end;

Procedure JKeyBO.JReadKey(var JKey : JKeyElt);
Var
  p : ^JKeyElt;
begin
  Repeat
  Until JKeyCodeBeginOffset <> JKeyCodeEndOffset;
  p := Ptr(JKeyBufSeg , JKeyCodeBeginOffset);
  JKey := p^;
  JKeyCodeBeginOffset := JKeyCodeBeginOffset + 3;
   if JKeyCodeBeginOffset > JKeyBufEndOffset then
    JKeyCodeBeginOffset := JKeyBufBeginOffset;
end;
{******************************End Key port****************************}



BEGIN
  KeyProc1 := Nothing;
  KeyProc2 := Nothing;
END.


{	sub	ax,ax			; Check out keyboard flags
	mov	ds,ax
	mov	al, BYTE PTR ds:[417h]

Check_CA:
	and	al, 0Ch
	cmp	al, 0Ch			; Control and alt?
	jz	CheckDel

	cmp	al, 04h			; Control only?
	jnz	GoVect			; If not, forget it

	in	al, 60h			; Look for control C
	and	al, 7Fh			; Up or down
	cmp	al, 2Eh
	jz	Eat_It			; If so, make it vanish

	cmp	al, 46h			; Look for control break
	jz	Eat_It

	jnz	GoVect			; Otherwise let it pass

CheckDel:
	in      al,60h			; read the key
	and	al,7Fh
	cmp	al,53h			; DEL?
	jnz	GoVect			; if not, forget it

Eat_It:	in	al,61H			; Get value of keyboard control lines
	mov	ah,al			; Save it
	or	al,80h			; Set the "enable kbd" bit
	out	61H,al			;  and write it out the control port
	xchg	ah,al			; Fetch original control port value
	out	61H,al			;  and write it back
	mov	al,20H			; Send End-Of-Interrupt signal
	out	20H,al			;  to the 8259 Interrupt Controller

	mov	ax, WORD PTR cs:[TempD]
	mov	ds,ax
	mov	ax, WORD PTR cs:[TempA]
	iret

