unit _LoadUser;

interface
Procedure LoadUserDefaults;
Procedure SaveUserDefaults;

implementation
uses
  Forms, _String, SysUtils, _Buffers, _PasWord, ConstDef, _Dos, Dialogs, Controls, _Code, _Message;

Type
  E_LoadUser_Error = class(Exception);


Procedure SaveUserDefaults;
var
  uf		:String;
  error		:Word;
  buf		:BufferO;
  result	:Integer;
begin
  buf := bufferO.Create;
  uf := ProgramDir+userSubDir+ Filename(Pas.User)+'.DIR\SPL.CON';
   if test(uf) = False then
    begin
      result := MessageDlg('Can not fined the start up file create new?', mtError, [mbYes, mbNo], 0);
       if result <> mrYes then
	begin
	  MessageDlg('Can not continue with out start up file', mtError, [mbOk], 0);
	  Application.Terminate;
	  raise E_LoadUser_Error.Create('Error in _PasWord.Begin:'+ErrorCode(700));
	  exit;
	end
       else
	begin
	  CreateFile(uf);
	   if test(uf) = False then
	    begin
	      MessageDlg('Can not continue with out start up file', mtError, [mbOk], 0);
	      Application.Terminate;
	      raise E_LoadUser_Error.Create('Error in _PasWord.Begin:'+ErrorCode(700));
	      exit;
	    end;
	end;
    end;
  buf.Ovr(CurrentFile, 1);
  buf.Ovr(pas.User, 2);
   if InOrder then buf.Ovr('1', 3) else buf.Ovr('0',3);
   if DoFile then buf.Ovr('1', 4) else buf.Ovr('0',4);
  buf.Ovr(subDir, 5);
   if ReshowIfWave then buf.Ovr('1', 6) else buf.Ovr('0',6);
   if ShowIfWave then buf.Ovr('1', 7) else buf.Ovr('0',7);
//  buf.SetValueN('optionMenuPasLev', optionMenuPasLev);
//  buf.SetValueN('soundMenuPasLev', soundMenuPasLev);
//  buf.SetValueN('listSoundsPasLev',listSoundsPasLev);
//  buf.SetValueN('soundDelPasLev',soundDelPasLev);
//  buf.SetValueN('ChangeDBPasLev', ChangeDBPasLev);
//  buf.SetValueN('delFilePasLev', delFilePasLev);
//  buf.SetValueN('lookOtherUsersPasLev', lookOtherUsersPasLev);
//  buf.SetValueN('MakeWrongWordFileForOthers', MakeWrongWordFileForOthers);

  error := SaveBuffer(Buf, uf);
   if error <> 0 then
    begin
      MessageDlg(' Error saveing start up file buffer '+
	ErrorCode(error), mtError, [mbOk], 0);
      raise E_LoadUser_Error.Create('Error in _PasWord.Begin:'+ErrorCode(700));
    end;
  buf.Destroy;
end;


Procedure LoadUserDefaults;
var
  uf		: String;
  error		: Word;
  buf		: BufferO;
  result	: Integer;
begin
  uf := ProgramDir+userSubDir+ Filename(Pas.User)+'.DIR\SPL.CON';
   if test(uf) = False then
    begin
      result := MessageDlg('Can not fined the start up file create new?', mtError, [mbYes, mbNo], 0);
       if result <> mrYes then
	begin
	  MessageDlg('Can not continue with out start up file', mtError, [mbOk], 0);
	  Application.Terminate;
	  raise E_LoadUser_Error.Create('Error in _PasWord.Begin:'+ErrorCode(700));
	end
       else
	begin
	  CreateFile(uf);
	  buf := bufferO.Create;
	  buf.Ovr('WORDS0.SPL', 1);
	  buf.Ovr('Your name', 2);
	  buf.Ovr('0', 3);
	  buf.Ovr('1', 4);
	  buf.Ovr('', 5);
	  buf.Ovr('1', 6);
	  buf.Ovr('1', 7);
	  buf.Ovr('optionMenuPasLev=10', 8);
	  buf.Ovr('soundMenuPasLev=0', 9);
	  buf.Ovr('listSoundsPasLev=0', 10);
	  buf.Ovr('soundDelPasLev=250', 11);
	  buf.Ovr('ChangeDBPasLev=250', 12);
	  buf.Ovr('delFilePasLev=100', 13);
	  buf.Ovr('lookOtherUsersPasLev=200', 14);
	  buf.Ovr('MakeWrongWordFileForOthers=210', 15);

	  error := SaveBuffer(Buf, uf);
	  buf.Destroy;
	   if error <> 0 then
	    begin
	      MessageDlg(' Error saveing start up file buffer '+
		ErrorCode(error), mtError, [mbOk], 0);
	      raise E_LoadUser_Error.Create('Error in _PasWord.Begin:'+ErrorCode(700));
	    end;
	end;
    end;
  buf := bufferO.Create;
  error := LoadBuffer(Buf, uf);
   if error <> 0 then
    begin
      buf.Destroy;
      MessageDlg(' Error loading start up file buffer '+
	ErrorCode(error), mtError, [mbOk], 0);
      raise E_LoadUser_Error.Create('Error in _PasWord.Begin:'+ErrorCode(700));
    end
    else begin
      if buf.Len > 0 then CurrentFile := FileName(buf.Get(1))+ '.SPL';
      if buf.Len > 1 then {defaultName := buf.Get(2)};
      if (buf.Len > 2) and
      (buf.Get(3) = '1') then inOrder := True else inOrder := False;
      if (buf.Len > 3)
       and (buf.Get(4) = '1') then doFile := True
       else doFile := False;
      if (buf.Len > 4) then subDir := buf.get(5);
      if (buf.Len > 5) and
      (buf.Get(6) = '1') then ReshowIfWave := True else ReshowIfWave := False;
      if (buf.Len > 6) and
      (buf.Get(7) = '1') then ShowIfWave := True else ShowIfWave := False;
      if buf.ValueExists('optionMenuPasLev') then optionMenuPasLev := buf.GetValueN('optionMenuPasLev');
      if buf.ValueExists('soundMenuPasLev') then soundMenuPasLev := buf.GetValueN('soundMenuPasLev');
      if buf.ValueExists('listSoundsPasLev') then listSoundsPasLev := buf.GetValueN('listSoundsPasLev');
      if buf.ValueExists('soundDelPasLev') then soundDelPasLev := buf.GetValueN('soundDelPasLev');
      if buf.ValueExists('ChangeDBPasLev') then ChangeDBPasLev := buf.GetValueN('ChangeDBPasLev');
      if buf.ValueExists('delFilePasLev') then delFilePasLev := buf.GetValueN('delFilePasLev');
      if buf.ValueExists('lookOtherUsersPasLev') then lookOtherUsersPasLev := buf.GetValueN('lookOtherUsersPasLev');
      if buf.ValueExists('MakeWrongWordFileForOthers') then MakeWrongWordFileForOthers := buf.GetValueN('MakeWrongWordFileForOthers');
    end;
  buf.Destroy;
end;

end.
