unit _Measure;

interface
Const
//length
  m_yd  	= 0.9144;		// m in a yd
  yd_m  	= 1/m_yd; 		//~1.09 yd in a meter;
  m_ft  	= m_yd / 3; 		//~0.3048 m in a ft
  m_in  	= m_ft / 12; 		// ~0.0254 m in a inch
  in_m  	= 1/m_ft*12;		// ~39.37 inch in a meter
  mm_ft 	= m_in * 1000; 		// ~25.4 mm in a in
  mile_yd       = 1760;
  km_mile       = (m_yd * mile_yd) / 1000;	//~1.61 km to a mile
  mile_km       = 1 / km_mile; 			//~0.62 mile to a km
//area
  insq_m	= in_m * in_m; 		// ~1550.0 square inches in a square meter
  msq_ydsq      = yd_m * yd_m;
  ydsq_msq	= 1/msq_ydsq;
  m_sq_hectare  = 10000; 		// 10000 sq m in a hectare
  yd_sq_acre    = 4840; 		// 4840 sq yd in a acre
  m_sq_acre     = yd_sq_acre * ydsq_msq;//~4047 sq m in a acre
  hectare_acre  = m_sq_acre / 10000; 	//~0.405 hactares in a acre
  acre_hectare  = 1 / hectare_acre; 	//~2.46 acres in a hectare
//volume
//  CubicMetersPerCubicInch = MetersPerInch * MetersPerInch * MetersPerInch;
//1 Cubic Meters = ~61023 Cubic Inchs
//1 gallon = 4.546 09 litres

//weight
  g_lb          = 453.59237; 	//grams in a lb
  kg_lb         = g_lb /1000; 	//~0.454 kg lb
//One newton meter is approximately 0.737 562 pound foot


  g_oz          = g_lb / 12; 	//~37.8 grams in a oz
//pressure
  psi_bar	= 14.50377439;	//1 bar = 10^5 N/m^2
  //1 bar lifts 33.45525633 ft or 10.19716213m  

function MetersToYards(x:real):real;
function YardsToMeters(x:real):real;
function FeetToMeters(x:real):real;
function MetersToFeet(x:real):real;
function kmToMiles(x:real):real;
function MilesTo_km(x:real):real;
function sqmTosqyd(x:real):real;
function kgPerHectareToLbPerAcre(x:real):real;
function LbPerAcreTokgPerHectare(x:real):real;
function kgToLb(x:real):real;
function lbTokg(x:real):real;

implementation
uses StdConvs;
function kgToLb(x:real):real ;
begin
  result := x / kg_lb
end;

function lbTokg(x:real):real ;
begin
  result := x * kg_lb
end;

function kgPerHectareToLbPerAcre(x:real):real;
begin
  result := (x / kg_lb) * hectare_acre;
end;

function LbPerAcreTokgPerHectare(x:real):real;
begin
  result := (x / hectare_acre) * kg_lb;
end;

function sqmTosqyd(x:real):real;
begin
  result := x * msq_ydsq
end;

function kmToMiles(x:real):real;
begin
  result := x / km_mile;
end;

function MilesTo_km(x:real):real;
begin
  result := x * km_mile;
end;

function MetersToYards(x:real):real;
begin
  result := x / m_yd;
end;

function YardsToMeters(x:real):real;
begin
  result := x * m_yd;
end;

function FeetToMeters(x:real):real;
begin
  result := x * m_ft;
end;

function MetersToFeet(x:real):real;
begin
  result := x / m_ft;
end;

var
 x :real;
begin


end.
