{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,R-,S+,V+,X-}
Unit _Win2;

INTERFACE

uses {crt,} _Screen, _Buffers;
Const
  winErrorCheck	: Boolean = True;
  fillC		: Char = '#';
  fillA		: Byte = TextAttr;
  WindLen	= 14;
  ScrSaveRLen	= 7;
  border : Boolean = True;
  shadow : Boolean = False;
  desktop	: Boolean = True;
  desktopC	: Char = '';
  desktopA	: Byte = TextAttr;
  screenSave	: Boolean = False;
  defaultPage	= 0;
  page0		= defaultPage;
  page1		= 1;
  page2		= 2;
  page3		= 3;
  page4		= 4;
  page5		= 5;
  page6		= 6;
  page7		= 7;
  page8		= 8;
  borderMask	= 1;
  shadowMask	= 2;
  hiddenMask	= 4;
  no_memMask	= 8;
  opMask	= $FF;
  writeScroll	: Boolean = True;
  cy		: Byte = 1;
  cx		: Byte = 1;

type
  FrameAttrT	= array[1..8] of Byte;
  FrameCharT	= String[8];

const
  normFrameAttr	: FrameAttrT = (White, White, White, White, White, White, White, White);
  testFrameAttr	: FrameAttrT = (BlueB, GreenC, MagentaB, RedB,
				BlueC, GreenB, YellowC, RedC);
  hiFrameAttr	: FrameAttrT = (112, 112, 112, 112, 112, 112, 112, 112);
  testFrame	: FrameCharT	= 'ķͼ';
  doubleFrame	: FrameCharT	= 'ͻͼ';
  singleFrame	: FrameCharT	= 'Ŀ';
  blockFrame	: FrameCharT	= '';
  shadeFrame	: FrameCharT	= '';

Type  {Windows & Basic Windows}
  WindRT = Record
	   x,y,width,depth,  {bit 0 = border}
	   op,{-------------<     1 = shadow}
	   page:Byte;	     {    2 = hidden}
	   id : Word;        {    3 = no mem}
	   cx, cy	:Byte;
	   screen:ScrTP;
	 end;
  WindP = ^WindRT;

  ScrSaveR = record
	       width, depth, page	:Byte;
	       screen			:ScrTP;
	     end;
  ScrSaveRP = ^ScrSaveR;

{******************************* Windows Procs ******************************}
Procedure DelAllWindows;
Procedure DelWindow2(BufPos :word);
Procedure DelWindow(wind: Word; page: Byte);
Function CenterWindow(    width, depth, page :Byte; title:String):Word;
Function DefineWindow(x, y, width, depth, page :Byte; title:String):Word;
Function MakeWindow  (x, y, width, depth, page :Byte; title:String):Word;
Procedure HideWindow   (Id: Word; page: Byte);
Procedure ShowWindow   (Id: Word; page: Byte);
Procedure RemoveWindow (iD: Word; page: Byte);
Procedure UpDateFrom   (window: Word; page: Byte);
Procedure UpDateWP(page: Byte);

Procedure SetFrameC(fC: FrameCharT);
Procedure SetFrameAttr(fA: FrameAttrT);


Procedure FreeWindowMem(window: Word; page: Byte);

Procedure MoveWindowTo(x,y,         window: Word; page: Byte);
Procedure MoveWindowBy(x,y:integer; window: Word; page: Byte);
Procedure MoveWindowToCenter(       window: Word; page: Byte);

Function ConvertWindToID(wind: Word; page: Byte):Word; {Assembler;}
{Function CurrentWindow(page:byte):word;}
Function CurrentWindowID(page:byte):word;
Function WindowId(depth, page: byte):word;
Function WindowExists(window : Word; page:byte):boolean;
Function WindowHidden(iD : Word; page:Byte):boolean;
Function WindIDExists(id : Word):Boolean;
Function GetNumOfWindOnPage(page:Byte):Word;
	{number of windows with out hidden windows}
Function GetNumOfHidden(page:word):word;
Function GetTotalWindOnPage(page:Word):Word;
	{number of windows with hidden windows}

Function GetIDPosInBuf(iD :Word; page: Byte): Word;
Function  GetWindow(window : word; page : Byte): windP;
	{not counting hidden windows}
Function  IDGetWindow(ID : Word; page :Byte): windP;
{Function  GetPageFromID(ID : Word): word;}
{Function  GetWindowIncludeHidden(window : word; page : Byte):windP;}
Function  GetWindRec(x,y,width,depth,page:Byte):WindP;
Procedure PutWindRec(    p:WindP);
Procedure FreeWindRec(   p:WindP);
{****************************End Windows Procs ******************************}
{************************Begin Windows write Procs **************************}
Function XYToInWindowN(x: Word; y, wind, page: Byte):Word;
{Takes x & y (relative to the window) and outputs n (Pos in scren mem)}

Function SetXY(x : Word; y : Byte; window: Word; page : Byte): Word; {Assembler;}
{if x is > the width of the window then divide x by width of window & add
to y then make x = remainder}

Procedure WindSetCursorXY(x, y, window, page: Word);
	{set's cursor x y in window relative to the window. if x > window
	width then x := x div window width and y = y + x mod window width }

Procedure UpDataCursor(page: Byte);
	{if window on screen then set's cursor x y to pos
	stored in wind rec else	sets cursor x y to cx, cy}

Function SetXYInWind(var x2:word;var y2:Byte;x:word;y,window,page:Byte):Word; {Assembler;}
{set's x2 & y2 to be relative to the screen instead of the window}
{*************************End Windows write Procs ***************************}


{************************** Begin Basic Windows Procs ***********************}
Function ToInWindow(n: Word; wind: Word; page: Byte):Word;
Procedure AddToWindCursor(wind: Word; page, num: Byte);
Procedure InitPage(page : Byte);
Procedure RestorePage(page : Byte);
Function GetScrSave(page: Byte): ScrSaveRP;
Function PageInit(page : Byte):Boolean;

Procedure UpDataWinPage(Page : Byte);
procedure UpDataCxCy(page: Byte);
	{Up data cx and cy in window record}
Procedure SetWindow(x, y, width, depth, page :Byte);
Procedure SetWindowWithBorder(x, y, width, depth, page: Byte; title: String);
Function GetNextId: Word;

Procedure Window             (x,y,width,depth:Byte);
Procedure WindowWithBorder   (x,y,width,depth:Byte; title:String);
Procedure WWrite(x : word; y: Byte; wind: Word; page: Byte; s : String);
{***************************** Windows Text Procs ***************************}

Function WindDepth(window : Word; page : Byte): Byte;
Function WindWidth(window : Word; page : Byte): Byte;

IMPLEMENTATION
Uses _KeyB, _String, _Dos;

var
  windBuf	: PointerBufO;
  screenBuf	: PointerBufO;
  x, errorR	: word;
  frame : Array[1..8] of elt;

Function GetBufPosOf(window: Word; page: Byte): Word;		Forward;
Function CurrentWindow(page:byte):word; far;			Forward;

Procedure DelAllWindows;
begin
  InOutZ;
   for x := 1 to WindBuf.Len do
    begin
      DelWindow2(1);
      {$IfNDef NoErrorCheck}
       if InOutError then
	begin
	  {$IfNDef NoErrorTrace}
	   TraceError(U_Win2, 101);
	  {$Endif NoErrorTrace}
	  exit;
	end;
      {$Endif}
    end;
end;

Procedure DelWindow(wind: Word; page: Byte);
begin
  InOutZ;
  FreeWindowMem(wind, page);
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 105);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  UpDateFrom(1, page);
end;

Function CenterWindow(width, depth, page : Byte; title : String) : Word;
begin
  CenterWindow := MakeWindow(((GetLineLength + 2) - width) div 2,
			     ((GetScreenRows + 2) - depth) div 2,
			     width, depth, page, title);
{$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 105);
{$EndIf}
end;

Function DefineWindow(x,y,width,depth,page: Byte; title:String):Word;
var
  p: WindP;
begin
  DefineWindow := MakeWindow(x, y, width, depth, page, title);
  p := WindBuf.Get(WindBuf.Len);
   with p^ do op := op or 4;
end;

Procedure DelWindow2(bufPos :Word);
var
  p : WindP;
  page	: Byte;
begin
  InOutZ;
  {$IfNDef NoErrorCheck}
   if bufPos < 1 then  begin InOut(541, 20, 203); TraceError(U_Win2, 135); Exit; end;
   if bufPos > windBuf.Len then  begin InOut(541, 20, 204); TraceError(U_Win2, 136); Exit; end;
  {$EndIf}
  p := windBuf.Get(bufPos);
  windBuf.Del(bufPos);
  page := p^.page;
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 105);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  FreeWindRec(p);
  UpDateFrom(1, page);
end;

Procedure SetFrameC(fC: FrameCharT);
begin
   for x := 1 to 8 do frame[x].ch := fC[x];
end;

Procedure SetFrameAttr(fA: FrameAttrT);
begin
   for x := 1 to 8 do frame[x].attr := fA[x];
end;

Function MakeWindow(x, y, width, depth, page: Byte; title: String):Word;
var
  p :WindP;
  size	: Word;
begin
   if winErrorCheck then
    begin
       InOutZ;
       if width < 1 then
	begin
	  InOut(543, 20, 245);
	  exit;
	end;
       if depth < 1 then
	begin
	  InOut(544, 20, 245);
	  exit;
	end;
       if x < 1 then
	begin
	  x := GetLineLength + 2 - width;
	   if x <= 0 then begin InOut(534, 20, 245); Exit; end;
	  x := x div 2;
	end;
       if y < 1 then
	begin
	  y := GetScreenRows + 2 - depth;
	   if y <= 0 then begin InOut(535, 20, 245); Exit; end;
	  y := y div 2;
	end;
       if page > GetMaxNumOfPages then begin InOut(503, 20, 230); Exit; end;
    end;
   if page = 0 then page := GetCurrentPage;
   if length(title) > width then width := length(title);
{   if border then size := (width + 1) * (depth + 1)
   else size := width * depth;}
  UpDataWinPage(Page);
  {$IfNDef NoErrorCheck}
   if winErrorCheck then
    begin
       if InOutError then
	begin
      {$IfNDef NoErrorTrace}
	  TraceError(U_Win2, 185);
      {$EndIf}
	  exit;
	end;
    end;
  {$EndIf}
   if MemAvail < SizeOf(windRT) then  begin if winErrorCheck then InOut(520, 20, 245); Exit; end;
  GetMem(p, SizeOf(windRT));
   if Border then
    begin
       if x < 2 then x := 2;
       if y < 2 then y := 2;
      SetWindowWithBorder(x, y, width, depth, page, title);
       {$IfNDef NoErrorCheck}
       if winErrorCheck then
	begin
	   if InOutError then
	    begin
	      {$IfNDef NoErrorTrace}
	       TraceError(U_Win2, 124);
	      {$EndIf}
	      exit;
	    end;
	end;
       {$EndIf}
      p^.x := x - 1;
      p^.y := y - 1;
      p^.width := width + 2;
      p^.depth := depth + 2;
      p^.op := no_memMask + borderMask;
    end
    else begin
      SetWindow(x, y, width, depth, page);
       {$IfNDef NoErrorCheck}
       if winErrorCheck then
	begin
	   if InOutError then
	    begin
	      {$IfNDef NoErrorTrace}
	      TraceError(U_Win2, 144);
	      {$EndIf}
	      exit;
	    end;
	end;
       {$EndIf}
      p^.x := x;
      p^.y := y;
      p^.width := width;
      p^.depth := depth;
      p^.op := no_memMask;
    end;
  p^.op := p^.op or no_memMask;
  p^.page := page;
  p^.id := GetNextId;
  p^.cx := 1;
  p^.cy := 1;
  p^.screen := nil;
   if shadow then p^.op := p^.op or 2;
  windBuf.Add(p);
  MakeWindow := windBuf.Len;
end;

Procedure HideWindow   (ID: Word; page: Byte);
var
  p		: WindP;
begin
  InOutZ;
   if page = 0 then page := GetCurrentPage;
  UpDataWinPage(Page);
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
  {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
  {$EndIf}
      exit;
    end;
  {$EndIf}
  p := IDGetWindow(iD, page);
  p^.op := p^.op or hiddenMask;
  UpDateFrom(1, page);
  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 271);
  {$EndIf}
end;

Procedure ShowWindow(Id: Word; page: Byte);
var
  p		: WindP;
begin
  InOutZ;
   if page = 0 then page := GetCurrentPage;
  UpDataWinPage(Page);
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
  {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
  {$EndIf}
      exit;
    end;
  {$EndIf}
  p := IDGetWindow(iD, page);
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
  {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
  {$EndIf}
      exit;
    end;
  {$EndIf}
  p^.op := p^.op and (opMask - hiddenMask);
  UpDateFrom(1, page);
  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 271);
  {$EndIf}
end;

Procedure UpDataWinPage(Page : Byte);
var
  p : WindP;
  e : Word;
begin
  InOutZ;
   if page = 0 then page := GetCurrentPage;
   if not PageInit(page) then InitPage(page);
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
  {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
  {$EndIf}
      exit;
    end;
  {$EndIf}
   if GetNumOfWindOnPage(page) < 1 then exit;
  p := GetWindow(CurrentWindow(page), page);
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
   if p^.screen = Nil then
    begin
      e := GetScrMem(p^.Screen , p^.x, p^.y, p^.width, p^.depth, p^.page);
      p^.op := p^.op and $FF - no_memMask;
      {$IfNDef NoErrorCheck}
       if e <> 0 then
	begin
	  p^.op := p^.op or no_memMask;
	  p^.Screen := Nil;
	  InOut(e, 20, 389);
	  {$IfNDef NoErrorTrace}
	  TraceError(U_Win2, 335);
	  {$EndIf}
	  exit;
	end;
      {$EndIf}
    end
    else begin
      {$IfNDef NoErrorCheck}
       if p^.screen^.size < p^.width * p^.depth then
	begin
	  InOut(520, 20, 401);
	  {$IfNDef NoErrorTrace}
	  TraceError(U_Win2, 321);
	  {$EndIf}
	  exit;
	end;
      {$EndIf}
      e := CopyScrMem(p^.Screen , p^.x, p^.y, p^.width, p^.depth, p^.page);
    end;
  {$IfNDef NoErrorCheck}
   if e <> 0 then
    begin
      InOut(e, 20, 413);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 320);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  UpDataCxCy(page);
end;

Function GetNextId: Word;
var
  p	: WindP;
  x, id : Word;
  quit	: Boolean;
  label l1;
begin
  InOutZ;
  id := 1;
    repeat
l1:    quit := True;
       for x := 1 to windBuf.Len do
	begin
	  p := windBuf.Get(x);
	   if id = p^.id then
	    begin
	      inc(id);
	      quit := False;
	      Goto l1;
	    end;
	end;
    until quit;
  GetNextId := id;
end;

Procedure RestorePage(page : Byte);
var
  p	:ScrSaveRP;
  e	:Word;
begin
   If not PageInit(page) then
    begin
      Cls(1, 1, GetLineLength, GetScreenRows, page, #0, TextAttr)
    end
    else begin
      p := GetScrSave(page);
       if p^.screen <> nil then e := SetScrMem(p^.screen,1,2,p^.width,p^.depth,page);
      {$IfNDef NoErrorCheck}
       if e <> 0 then
	begin
	  InOut(e, 20, 463);
	  {$IfNDef NoErrorTrace}
	  TraceError(U_Win2, 185);
	  {$EndIf}
	  exit;
	end;
      {$EndIf}
    end;
end;

Procedure InitPage(page : Byte);
var
  p :ScrSaveRP;
  e :Word;
begin
   if page = 0 then page := GetCurrentPage;
   if PageInit(page) then exit;
   if MemAvail < ScrSaveRLen then  begin InOut(520, 20, 480); Exit; end;
  GetMem(p, ScrSaveRLen);
  p^.width := GetLineLength;
  p^.depth := GetScreenRows;
  p^.page := page;
   if screenSave then
    begin
      e := GetScrMem(p^.Screen , 1, 1, p^.width, p^.depth, page);
{      p^.op := p^.op and $FF - no_memMask;}
      {$IfNDef NoErrorCheck}
       if e <> 0 then
	begin
{	  p^.op := p^.op or no_memMask;}
	  p^.Screen := Nil;
	  InOut(e, 20, 494);
	  {$IfNDef NoErrorTrace}
	  TraceError(U_Win2, 335);
	  {$EndIf}
	  exit;
	end;
      {$EndIf}
    end
   else p^.screen := Nil;
  screenBuf.Add(p);
end;

Function PageInit(page : Byte):Boolean;
var
  p :ScrSaveRP;
begin
  InOutZ;
   if page = 0 then page := GetCurrentPage;
   if screenBuf.Len < 1 then PageInit := False
    else begin
      p := screenBuf.Get(1);
      x := 2;
       While (x <= screenBuf.Len) and (p^.page <> page) do
	begin
	  p := screenBuf.get(x);
	  inc(x);
	end;
       if p^.page = page then PageInit := True
       else PageInit := False;
    end;
end;

Function GetScrSave(page: Byte): ScrSaveRP;
var
  p :ScrSaveRP;
begin
  InOutZ;
   if page = 0 then page := GetCurrentPage;
   if screenBuf.Len < 1 then GetScrSave := Nil
    else begin
      p := screenBuf.Get(1);
      x := 2;
       While (x <= screenBuf.Len) and (p^.page <> page) do
	begin
	  p := screenBuf.get(x);
	  inc(x);
	end;
      GetScrSave := p
    end;
end;

Procedure UpDateWP(page: Byte);
begin
  UpDateFrom(0, page);
end;


Procedure UpDateFrom(window : Word; page : Byte);
var
  p 	: WindP;
  p2	: ScrSaveRP;
  e, x	: Word;
begin
  InOutZ;
  {$IfNDef NoErrorCheck}
   if page > GetMaxNumOfPages then
    begin
      InOut(540, 20, 556);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
   if page = 0 then page := GetCurrentPage;
{   if window > GetNumOfWindOnPage(page) then exit;}
   if not PageInit(page) then InitPage(page);
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
  {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
  {$EndIf}
      exit;
    end;
  {$EndIf}
   if desktop then Cls(1, 1, GetLineLength, GetScreenRows, page, desktopC, desktopA)
    else begin
      p2 := GetScrSave(page);
       if p2^.screen <> nil then e := SetScrMem(p2^.screen,1,2,p2^.width,p2^.depth,page);
      {$IfNDef NoErrorCheck}
       if e <> 0 then
	begin
	  InOut(e, 20, 582);
	  {$IfNDef NoErrorTrace}
	  TraceError(U_Win2, 185);
	  {$EndIf}
	  exit;
	end;
      {$EndIf}
    end;
   for x := 1 to GetNumOfWindOnPage(page) do
    begin
      p := GetWindow(x, page);
      PutWindRec(p);
      {$IfNDef NoErrorCheck}
       if InOutError then
	begin
	  {$IfNDef NoErrorTrace}
	  TraceError(U_Win2, 185);
	  {$EndIf}
	  exit;
	end;
      {$EndIf}
    end;
   if page = 1 then
    begin
       if GetNumOfWindOnPage(page) < 1 then
	begin
	  _win2.window(1, 1, GetLineLength, GetScreenRows);
	end
	else begin
	  p := GetWindow(0, page);
	   if p^.op and borderMask > 0 then
	   with p^ do crt.Window(x+1 , y+1, (x+1) + (width-2)-1, (y+1) + (depth-2)-1)
	   else with p^ do crt.Window(x, y, (x) + (width), (y) + (depth));
	   GotoXY(p^.cx, p^.cy);
	end;
    end;
  UpDataCursor(page);
end;

Function CurrentWindow(page: Byte): Word; Assembler;
asm
	push	page.word
	call	GetNumOfWindOnPage
end;

Procedure RemoveWindow (iD: Word; page: Byte);
begin
  InOutZ;
   if page = 0 then page := GetCurrentPage;
   if iD = 0 then iD := CurrentWindowID(page);
  {$IfNDef NoErrorCheck}
   if iD = 0 then
    begin
      InOut(541, 20, 635);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  p := IDGetWindow(iD, page);
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  windBuf.Del(GetIDPosInBuf(iD, Page));
  FreeWindRec(p);
  UpDateFrom(1, page);
  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}
end;

Procedure FreeWindowMem(window: Word; page: Byte);
begin
  InOutZ;
   if page = 0 then page := GetCurrentPage;
   if window = 0 then window := CurrentWindow(page);
  {$IfNDef NoErrorCheck}
   if window = 0 then
    begin
      InOut(541, 20, 668);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 670);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  p := GetWindow(window, page);
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 680);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  windBuf.Del(GetBufPosOf(window, Page));
  FreeWindRec(p);
  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}
end;


Function GetBufPosOf(window: Word; page: Byte): Word;
var
  p:		WindP;
  num, x:	Word;
begin
  InOutZ;
   if page = 0 then page := GetCurrentPage;
   if window = 0 then window := CurrentWindow(page);
  {$IfNDef NoErrorCheck}
   if window = 0 then
    begin
      InOut(541, 20, 704);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  num := 0;
   for x := 1 to windBuf.Len do
    begin
      p := windBuf.Get(x);
       if (p^.page = page) and (p^.op and hiddenMask = 0) then
	begin
	  inc(num);
	   if num = window then
	    begin
	      GetBufPosOf := x;
	      exit;
	    end;
	end;
    end;
  {$IfNDef NoErrorCheck}
  InOut(541, 20, 726);
  {$IfNDef NoErrorTrace}
  TraceError(U_Win2, 728);
  {$EndIf}
  {$EndIf}
end;

Function GetIDPosInBuf(iD :Word; page: Byte): Word;
var
  p	:WindP;
begin
  InOutZ;
  GetIDPosInBuf := 0;
   if page = 0 then page := GetCurrentPage;
   if iD = 0 then iD := CurrentWindowID(page);
  {$IfNDef NoErrorCheck}
   if iD = 0 then
    begin
      InOut(541, 20, 744);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
   for x := 1 to windBuf.Len do
    begin
      p := windBuf.Get(x);
       if p^.iD = iD then
	begin
	  {$IfNDef NoErrorCheck}
	   if p^.page <> page then
	    begin
	      InOut(541, 20, 759);
	      {$IfNDef NoErrorTrace}
	      TraceError(U_Win2, 761);
	      {$EndIf}
	    end;
	  {$EndIf}
	  GetIDPosInBuf := x;
	  exit;
	end;
    end;
  {$IfNDef NoErrorCheck}
  InOut(541, 20, 770);
  {$IfNDef NoErrorTrace}
  TraceError(U_Win2, 698);
  {$EndIf}
  {$EndIf}
end;

Procedure MoveWindowBy(x,y:integer; window: Word; page: Byte);
var
  p	: WindP;
begin
  InOutZ;
   if page = 0 then page := GetCurrentPage;
   if window = 0 then window := CurrentWindow(page);
  {$IfNDef NoErrorCheck}
   if window = 0 then
    begin
      InOut(541, 20, 787);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  p := GetWindow(window,page);
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  MoveWindowTo(p^.x+x,p^.y+y,window,page);
  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}
end;

Procedure MoveWindowTo(x,y,window : Word; page : Byte);
var
  p	: WindP;
begin
  InOutZ;
   if page = 0 then page := GetCurrentPage;
   if window = 0 then window := CurrentWindow(page);
  {$IfNDef NoErrorCheck}
   if window = 0 then
    begin
      InOut(541, 20, 870);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  p := GetWindow(window,page);
   if x < 1 then InOut(500, 20, 828)
   else if y < 1 then InOut(504, 20, 829)
   else if (x - 1) + p^.width > GetLineLength then InOut(536, 20, 830)
   else if (y - 1) + p^.depth > GetScreenRows then InOut(539, 20, 831)
    else begin
      p^.x := x;
      p^.y := y;
    end;
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  ShowWindow(window,page);
  UpDateFrom(1, page);
  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}
end;

Procedure MoveWindowToCenter(window : Word; page : Byte);
var
  p	: WindP;
begin
  InOutZ;
   if page = 0 then page := GetCurrentPage;
   if window = 0 then window := CurrentWindow(page);
  {$IfNDef NoErrorCheck}
   if window = 0 then
    begin
      InOut(541, 20, 862);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  p := GetWindow(window, page);
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  MoveWindowTo((GetLineLength - p^.width) div 2,
	       (GetScreenRows - p^.depth) div 2, window, page);
  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}
end;

Function CurrentWindowID(page:byte):word;
var
  i	:word;
  p	:windP;
begin
  InOutZ;
  {$IfNDef NoErrorCheck}
   if page>getmaxnumofpages then
    begin
      Inout(540, 20, 895);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
   if page=0 then page:=GetCurrentPage;
  {$IfNDef NoErrorCheck}
   if InOutError then
    begin
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  for i:=windbuf.Len downto 1 do
    begin
      p:=windbuf.get(i);
      {$IfNDef NoErrorCheck}
       if InOutError then
	begin
	  {$IfNDef NoErrorTrace}
	  TraceError(U_Win2, 185);
	  {$EndIf}
	  exit;
	end;
      {$EndIf}
      if p^.page = page  then
	begin
	  CurrentWindowID :=p^.id;
	  exit;
	end;
    end;
  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}
end;

Function WindowId(depth,page:byte):word;
var
  i	:word;
  d	:byte;
  p	:windP;
begin
  InOutZ;
  {$IfNDef NoErrorCheck}
   if page > getmaxnumofpages then InOut(540, 20, 978) else
  {$EndIf}
  if page=0 then page:=GetCurrentPage;
  d:=0;
  for i:=1 to windbuf.Len  do
    begin
      p:=windbuf.get(i);
       if (p^.page=page) and ((p^.op and HiddenMask) = 0) then
	begin
	  inc(d);
	   if d=depth then
	    begin
	      WindowId := p^.id;
	      exit;
	    end;
	end;
    end;
end;

Function WindowExists(window : Word; page:byte):boolean;
var
  p	:windp;
begin
  InOutZ;
  p := GetWindow(window,page);
   if (InOutError) and (GetLastInOutError = 541) then
    begin
      WindowExists := False;
      asm call TestInOutError end;
      exit;
    end;
  WindowExists := True;
end;

Function WindowHidden(id : word; page : Byte):boolean;
const p:windp=nil;
begin
  InOutZ;
  p := IDGetWindow(ID,page);
  WindowHidden:=(p^.op and 4) <> 0;
  {$IfNDef NoErrorCheck}
  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}
  {$EndIf}
end;

Function GetNumOfWindOnPage(page:byte):word;
const i:word=0;
      c:word=0;
      p:windp=nil;
begin
  InOutZ;
   if page>getmaxnumofpages then begin GetNumOfWindOnPage:=0; exit; end;
   if page=0 then page:=GetCurrentPage;
  GetNumOfWindOnPage :=0;
  c:=0;
   for i:=1 to windbuf.len do
    begin
      p:=windbuf.get(i);
       if (p^.page=page) and ((p^.op and hiddenMask) = 0) then inc(c);
    end;
  GetNumOfWindOnPage :=c;
  {$IfNDef NoErrorCheck}  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}  {$EndIf}
end;

Function GetTotalWindOnPage(page:Word):Word;
const
  p:windP=nil;
  c:word=0;
  x:word=0;
begin
  InOutZ;
   if page>getmaxnumofpages then begin GetTotalWindOnPage:=0; exit; end;
   if page=0 then page:=GetCurrentPage;
  c := 0;
   for x := 1 to windBuf.Len do
    begin
      p:=WindP(windBuf.Get(x));
       if p^.page = page then inc(c);
    end;
  GetTotalWindOnPage := c;
  {$IfNDef NoErrorCheck}  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}  {$EndIf}
end;

Function GetNumOfHidden(page:word):word;
const i:word=0;
      c:word=0;
      p:windp=nil;
begin
  InOutZ;
   if page>getmaxnumofpages then begin GetNumOfHidden:=0; exit; end;
   if page=0 then page:=GetCurrentPage;
  GetNumOfHidden:=0;
  c:=0;
   for i:=1 to windbuf.len do
    begin
      p:=windbuf.get(i);
       if (p^.page=page) and ((p^.op and 4)<>0) then inc(c);
    end;
  GetNumOfHidden:=c;
  {$IfNDef NoErrorCheck}  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}  {$EndIf}
end;

Function WindIDExists(id : Word):Boolean;
var
  p	:WindP;
  x	:Word;
begin
   if windBuf.Len = 0 then WindIDExists := False
    else begin
      x := 2;
      p := windBuf.get(1);
       while (p^.id <> id) and (x <= windBuf.Len) do
	begin
	  p := windBuf.get(x);
	  inc(x);
	end;
       if p^.id = id then WindIDExists := True
       else WindIDExists := False;
    end;
end;

Function IDGetWindow(id : word; page : Byte):windP;
var
  i, num	: word;
  p		: WindP;
begin
  InOutZ;
  IDGetWindow := nil;
   if page>getmaxnumofpages then begin InOut(540, 20, 1114); exit; end;
   if page = 0 then page := GetCurrentPage;
   if iD = 0 then
    begin
      iD := CurrentWindowID(page);
       if iD = 0 then begin InOut(541, 20, 1119); exit; end;
      {$IfNDef NoErrorCheck}
       if InOutError then
	begin
	  {$IfNDef NoErrorTrace}
	  TraceError(U_Win2, 185);
	  {$EndIf}
	  exit;
	end;
      {$EndIf}
    end;
  num := 1;
  for i:=1 to windBuf.Len do
    begin
      p:=windBuf.get(i);
      {$IfNDef NoErrorTrace}
       if InOutError then begin TraceError(U_Win2, 1135); Exit; end;
      {$EndIf}
      if (p^.page=page) and (p^.iD = iD) then
       begin
	 IDGetWindow := p;
	 exit;
       end;
    end;
  {$IfNDef NoErrorCheck}
   if InOutError then
   else if WindIDExists(id) then InOut(541, 20, 1145)
   else InOut(541, 20, 1146);
  {$IfNDef NoErrorTrace}
  TraceError(U_Win2, 1046);
  {$EndIf}
  {$EndIf}
end;

Function GetWindow(window : word; page : Byte):windP;
var
  i, num	: word;
  p		: WindP;
begin
  InOutZ;
  GetWindow := nil;
   if GetNumOfWindOnPage(page) < 1 then begin InOut(541, 20, 1160); exit; end;
   if page>getmaxnumofpages then begin InOut(540, 20, 1161); exit; end;
   if page = 0 then page := GetCurrentPage;
   if window = 0 then
    begin
      window := CurrentWindow(page);
       if window = 0 then begin InOut(541, 20, 1166); exit; end;
      {$IfNDef NoErrorCheck}
       if InOutError then
	begin
	  {$IfNDef NoErrorTrace}
	  TraceError(U_Win2, 185);
	  {$EndIf}
	  exit;
	end;
      {$EndIf}
    end;
  num := 1;
  for i:=1 to windBuf.Len do
    begin
      p:=windBuf.get(i);
      {$IfNDef NoErrorTrace}
       if InOutError then TraceError(U_Win2, 185);
      {$EndIf}
      if (p^.page=page) and (p^.op and HiddenMask <> HiddenMask) then
       begin
	  if num = window then
	   begin
	     GetWindow := p;
	     exit;
	   end;
	 inc(num);
       end;
    end;
  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}
end;

Function GetWindRec(x,y,width,depth,page:Byte):windP;
var
  p : WindP;
begin
  InOutZ;
  GetWindRec:=nil;
   if MaxAvail > WindLen then
    GetMem(p,WindLen)
  {$IfNDef NoErrorCheck}
    else begin
      InOut(520, 20, 1209);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end;
  {$EndIf}
  errorR := GetScrMem(p^.screen,x,y,width,depth,page);
  p^.op := p^.op and $FF - no_memMask;
  if errorR <> 0 then
    begin
      FreeMem(p, WindLen);
      InOut(errorR, 20, 1221);
      {$IfNDef NoErrorTrace}
      TraceError(U_Win2, 185);
      {$EndIf}
      exit;
    end
  else
    begin
      p^.x := x;
      p^.y := y;
      p^.width := width;
      p^.depth := depth;
      if page = 0 then
	p^.page := GetCurrentPage
      else
	p^.page := page;
      GetWindRec := p;
    end;
  {$IfNDef NoErrorCheck}  {$IfNDef NoErrorTrace}
   if InOutError then TraceError(U_Win2, 185);
  {$EndIf}  {$EndIf}
end;

Procedure PutWindRec(p:WindP);
begin
  InOutZ;
  with p^ do
    errorR:=SetScrMem(screen,x,y,width,depth,page);
    {$IfNDef NoErrorCheck}
     if errorR <> 0 then
      begin
	InOut(errorR, 20, 1252);
	{$IfNDef NoErrorTrace}
	TraceError(U_Win2, 185);
	{$EndIf}
      end;
    {$EndIf}
end;

Function ConvertWindToID(wind: Word; page: Byte):Word; Assembler;
var
  p : WindP;
asm
	push	ss
	mov	ax, Offset p
	push	wind
	push	page.word
	call	GetWindow
	add	sp, 4
	les	di, p
	mov	ax, [es:di]._win2.windRT.id
{  p := GetWindow(wind, page);
  ConvertWindToID}
end;

Procedure FreeWindRec(p:WindP);
begin
   if p^.op and no_memMask = 0 then
    begin
       if p^.screen = Nil then InOut(521, 20, 1245);
      FreeScrMem(p^.screen);
    end;
  FreeMem(p, SizeOf(WindRT));
end;
{**************************Begin Basic Windows Proc's***********************}
Function WriteBox(x, y, width, depth, page : byte): Word; Assembler;
asm
  cmp	winErrorCheck, 0
  je	@s1
  push	x.word
  push	y.word
  push	width.word
  push	depth.word
  push	page.word
  call	CheckE
  cmp	ax, 0
  jne	@end
  cmp	width, 3
  jb	@end
  cmp	depth, 3
  jb	@end
@s1:
  dec	width
  dec	depth
  push	x.word
  push	y.word
  push	page.word
  push	frame.word(0)
  push	frame.word(1)
  call	DrectWriteC
  xor	ah, ah
  mov	al, x
  inc	al
  push	ax
  push	y.word
  mov	al, width
  dec	al
  push	ax
  mov	ax, 1
  push	ax
  push	page.word
  push	frame.word(2)
  push	frame.Word(3)
  call	Cls{(x, y, width, depth, page : Byte; c : Char; attr:byte)}
  xor	ah, ah
  mov	al, x
  add	al, width
  push	ax
  push	y.word
  push	page.word
  push	frame.word(4)
  push	frame.word(5)
  call	DrectWriteC
  push	x.word
  xor	ah, ah
  mov	al, y
  inc	al
  push	ax
  mov	ax, 1
  push	ax
  xor	ah, ah
  mov	al, depth
  dec	al
  push	ax
  push  page.word
  push  frame.word(6)
  push	frame.word(7)
  call	cls
  mov	al, x
  add	al, width
  push	ax
  mov	al, y
  inc	al
  push	ax
  mov	ax, 1
  push	ax
  mov	al, depth
  add	y, al
  dec	al
  push	ax
  push	page.word
  push  frame.word(8)
  push	frame.word(9)
  call	cls
  push	x.word
  push	y.word
  push	page.word
  push  frame.word(10)
  push	frame.word(11)
  call	DrectWriteC
  mov	al, x
  inc	al
  push	ax
  push	y.word
  mov	al, width
  dec	al
  push	ax
  mov	ax, 1
  push	ax
  push	page.word
  push  frame.word(12)
  push	frame.word(13)
  call	cls
  mov	al, x
  add	al, width
  push	ax
  push	y.word
  push	page.word
  push  frame.word(14)
  push	frame.word(15)
  call	DrectWriteC
  mov ax, 0
@end:
end;


Procedure SetWindow(x, y, width, depth, page : Byte);
begin
  cls(x, y, width, depth, page, fillC, fillA);
  SetCursorXY(x, y, page);
   if page = 0 then page := GetCurrentPage;
   if page = 1 then window(x, y, width, depth);
end;

Procedure SetWindowWithBorder(x, y, width,depth,page :Byte;title:String);
begin
  cls(x, y, width, depth, page, fillC, fillA);
  SetCursorXY(x, y, page);
   if page = 0 then page := GetCurrentPage;
   if page = 1 then WindowWithBorder(x, y, width, depth, title)
    else begin
      errorR := WriteBox(x - 1, y - 1, width + 2, depth + 2, page);
      CenterLineBetween(x, y - 1, width, 0, title, textAttr);
      Window(x, y, width, depth);
    end;
end;


Procedure Window(x, y, width, depth : Byte); Assembler;
var
  spt : Word;
asm
  mov	spt, sp
  call	GetLineLength {if x > GetLineLength then MakeWindow := 501}
  push	ax
  cmp	x, al
  mov	ax, 501
  ja	@end
  call	GetScreenRows	{else if y > GetScreenRows then MakeWindow := 505}
  push	ax
  cmp	y, al
  mov	ax, 505
  ja	@end
  mov	cl, depth	{else if depth + y -1 > GetSreenRows then MakeWindow := 539}
  add	cl, y
  mov	ax, 539
  jc	@end
  dec	cl
  pop	bx
  cmp	cl, bl
  ja	@end
  mov	cl, width	{else if width + x -1 > GetLineLength then MakeWindow := 536}
  add	cl, x
  mov	ax, 536
  jc    @end
  dec	cl
  pop	bx
  cmp   cl, bl
  ja	@end
  inc	cl
  sub	ah, ch          {else begin}
  mov	al, x		{  Crt.Window(x, y, x + width, y + depth);}
  push	ax		{  Window := 0;}
  mov	al, y           {end;}
  push	ax		
  sub	ch, ch
  dec	cx
  push	cx
  add	al, depth
  dec	ax
  push	ax
  call	Crt.Window
  mov	ax, 0;
@end:
  mov	sp, spt
end;

Procedure WindowWithBorder(x, y, width, depth : Byte; title : String);
Const
  s : String = '';
begin
   if x < 2 then InOut(500, 20, 1597)
   else if y < 2 then InOut(504, 20, 1598)
   else if x > GetLineLength - 1 then InOut(501, 20, 1599)
   else if y > GetScreenRows - 1 then
    InOut(505, 20, 1600)
   else if x + width > GetLineLength then InOut(536, 20, 1601)
   else if y + depth > GetScreenRows then InOut(539, 20, 1602)
    else begin
      errorR := WriteBox(x - 1, y - 1, width + 2, depth + 2, 1);
      CenterLineBetween(x, y - 1, width, 0, title, textAttr);
      Window(x, y, width, depth);
    end;
end;


Function WindDepth(window : Word; page : Byte) : Byte; {Assembler;}
var
  p : WindP;
begin
   if page = 0 then page := GetCurrentPage;
   if (page = 1) and ((window = 0) or (window = CurrentWindow(page))) then
    WindDepth := Hi(WindMax)-Hi(WindMin)+1
    else begin
      p := GetWindow(window, page);
       if (p^.op and 5) = 5 then WindDepth := p^.depth - 2
       else WindDepth := p^.depth;
    end;
end;

Function WindWidth(window : Word; page : Byte): Byte; Assembler;
var
  p : windP;
asm
	cmp	page, 0			{if page = 0 then}
	jne	@s1
	call	GetCurrentPage		{page := GetCurrentPage;}
	mov	page, al
@s1:	cmp	page, 1			{if (page = 1) and}
	jne	@e1
	cmp	window, 0		{((window = 0) or}
	je	@f1
	push	page.word               {(window = CurrentWindow(page))) then}
	call	CurrentWindow
	cmp	window, ax
	jne	@e1
@f1:	mov	al, windMax.byte	{WindWidth := Lo(windMax)-Lo(WindMin) + 1}
	sub	al, WindMin.byte
	inc	al
	jmp	@end
@e1:    push	page.word
	call	GetNumOfWindOnPage
	cmp	ax, 0
	jne	@s2
	xor	al, 0
	jmp	@end
@s2:	push	window
	push	page.word
	call	GetWindow
	mov	es, ax
	mov	di, dx
	mov	al, WindRT([es:di]).width
	mov	ah, 1
	and	ah, WindRT([es:di]).op
	cmp	ah, 1
	jne	@e2
	sub	al, 2
@e2:
@end:	xor	ah, ah
{    else begin
      p := GetWindow(window, page));
       if (p^.op and 1) = 1 then WindWidth := p^.width - 2
       else WindWidth := p^.width;
    end;}
end;


{**************************End Basic Windows Proc's***********************}
{************************Begin Windows write Procs **************************}
Function XYToInWindowN(x: Word; y, wind, page: Byte):Word;
{Takes x & y (relative to the window) and outputs n (Pos in scren mem)}
var
  bW:	Word;
  p:	WindP;
begin
   if y = 0 then inc(y);
   if x = 0 then inc(x);
  p := GetWindow(wind, page);
   if p^.op and borderMask <> 0 then bW := 1
   else	bW := 0;
  XYToInWindowN := (((y-1) + (p^.y-1) + bW) * GetLineLength) + ((x - 1) + p^.x + bW);
end;

Procedure ScrollWindowMem(window: word; page: Byte);
var
  bordersWidth, width, depth:	Word;
  p1:				Pointer;
  p:				WindP;
begin
  p := GetWindow(window, page);
  width := p^.width;
  depth := p^.depth;
  p1 := addr(p^.screen^.screen);
  bordersWidth := 0;
   if p^.op and borderMask > 0 then bordersWidth := 2;
asm
	push	ds
	les	di, p1
	lds	si, p1
	mov	dx, width
	shl	dx, 1
	add	di, dx
	shl	dx, 1
	add	si, dx
	shr	dx, 1
	shr	dx, 1
	mov	ax, bordersWidth
	sub	dx, ax
{	shr	ax, 1}
	add	si, ax
	add	di, ax
	mov	bx, depth
	sub	bx, ax
	shl	ax, 1
	cmp	bx, 1
	jnb	@s1
	pop	ds
	jmp	@exit
@s1:
	je	@blankL
@l1:	cmp	bx, 1
	jbe	@blankL
	mov	cx, dx
	rep	movsw
	dec	bx
	add	si, ax
	add	di, ax
	cmp	bx, 0
	jne	@l1
@blankL:
	pop	ds
	mov	ah, fillA
	mov	al, fillC
	mov	cx, dx
	rep	stosw
@exit:
end;end;

Procedure UpDataCursor(page: Byte);
{if window on screen then set's cursor x y to pos stored in wind rec else
sets cursor x y to cx, cy}
var
  p:	windP;
begin
   if GetNumOfWindOnPage(page) < 1 then
    begin
      SetCursorXY(cx, cy, page);
    end
    else begin
      p := GetWindow(0, page);
      WindSetCursorXY(p^.cx, p^.cy, 0, page);
    end;
end;

procedure UpDataCxCy(page: Byte);
var
  p:	windP;
  BorderWidth:	byte;
begin
   if GetNumOfWindOnPage(page) < 1 then
    begin
      cx := GetCursorX(page);
      cy := GetCursorY(page);
    end
    else begin
      p := GetWindow(0, page);
       if (p^.op and borderMask) = 0 then BorderWidth := 0
       else BorderWidth := 1;
      p^.cx := (GetCursorX(page) - (p^.x-1)) - BorderWidth;
      p^.cy := (GetCursorY(page) - (p^.y-1)) - BorderWidth;
    end;
end;

Procedure WindSetCursorXY(x, y, window, page: Word);
{set's cursor x y in window relative to the window. if x > window width then
x := x div window width and y = y + x mod window width }
var
  borderWidth:	byte;
  p:	WindP;
begin
   if GetNumOfWindOnPage(page) < 1 then
    begin
       if x > GetLineLength then
	begin
	  x := x div GetLineLength;
	  y := y + (x mod GetLineLength);
	end;
      SetCursorXY(x, y, page);
    end
    else begin
      p := GetWindow(window, page);
       if x > p^.width then
	begin
	  x := x div p^.width;
	  y := y + (x mod p^.width);
	end;
       if p^.op and borderMask > 0 then borderWidth := 1
       else borderWidth := 0;
      x := x + (p^.x-1) + borderwidth;
      y := y + (p^.y-1) + borderwidth;
      SetCursorXY(x, y, page);
    end;
end;

Function SetXY(x : Word; y : Byte; window: Word; page : Byte): Word; Assembler;
Var
  p : WindP;
  borderWidth : Byte;
asm
	mov	borderWidth, 0
	mov	ax, seg p
	push	ax
	mov	ax, offset p
	push	ax
  mov	ax, window
  push	ax
  xor	ah, ah
  mov	al, page
  push	ax
  call	GetWindow {p := GetWindow(window , page);}
  les	di, p
  mov	ax, es
  cmp	ax, 0
  je	@e1
  cmp	di, ax
  jne	@s1
@e1:	mov	ax, 541
	call	InOutAsm
	jmp	@end
@s1:    mov	al, windRT([es:di]).width
	mov	bl, windRT([es:di]).depth
	mov	bh, windRT([es:di]).op
	and	bh, 00000001b
	cmp	bh, ah
	ja	@s2
	sub	al, 2
	sub	bl, 2
	mov	borderWidth, 1
@s2:    cmp	al, ah
	jne	@s3
	mov	ax, 531
	call	InOutAsm
	jmp	@end
@s3:	cmp	bl, ah
	jne	@s4
	mov	ax, 532
	call	InOutAsm
	jmp	@end
@s4:	mov	dx, x
	mov	bh, y
	cmp	dx, ax			{if x not > width then goto @q1;}
	jna	@q1
@l1:	cmp	dx, ax
	jna	@q1
	inc	bh
	cmp	bh, bl
	ja	@end
	sub	dx, ax
	jmp	@l1
@q1:
	les	di, p
	add	dl, windRT([es:di]).x
	add	dl, borderWidth
	add	bh, windRT([es:di]).y
	add	bh, borderWidth
	push	dx
	xor	bl, bl
	push	bx
	push	page.word
	call	SetCursorXY
@end:
end;

Function SetXYInWind(var x2:word;var y2:Byte;x:word;y,window,page:Byte):Word; Assembler;
var
  p : WindP;
asm
  push	ss				{ax := SetXY(x, y);}
  mov	di, bp
  add	di, offset x
  push	di
  push	ss
  mov	di, bp
  add	di, offset y
  push	di
  call	SetXY
  cmp	ax, 0
  jne	@end
  les	di, p				{ax := GetWindow(p, window, page);}
  push	es
  push	di
  mov	al, window
  push	ax
  mov	al, page
  push	ax
  call	GetWindow
  cmp	ax, 0
  jne	@end
  les	di, p				{al := p^.x + x;}
  mov	al, [es:di]
  add	ax, x
  mov	bl, [es:di + 1]			{bl := p^.y + y;}
  add	bl, y
  mov	bh, [es:di + 4]
  and	bh, 00000001b
  cmp	bh, 0				{if not border then}
  jne	@s1
  dec	al				{dec(x2);}
  dec	bl				{dec(y2);}
@s1:
  les	di, x2
  mov	[es:di], ax
  xor	bh, bh
  les	di, y2
  mov	[es:di], bx
  mov	ax, 0
@end:
end;

Procedure GetXYCoordinatesOf(n : Word; var x, y : Word;wind:Word;page:Byte); Assembler;
asm
	push	wind
	push	page.word
	call	WindWidth
	mov	cl, al
	xor	ch, ch
	xor	dx, dx
	mov	ax, n
	div	cx
	les	di, x
	mov	[es:di], dx
	les	di, y
	inc	ax
	mov	[es:di], ax
end;
{  y := Trunc(n / GetLineLength);
  x := n - (y * GetLineLength);
  Inc(y);
end;}

procedure WriteWindowMem(x: word; y: Byte; window: Word; page: Byte; s: String);
var
  p:	WindP;
  p1:	Pointer;
  width, depth, borderW, AddToDi:	Word;
begin
  p := GetWindow(window, page);
  width := p^.width;
  depth := p^.depth;
  borderW := 0;
   if p^.op and borderMask <> 0 then
    begin
      depth := depth - 2;
      width := width - 2;
      borderW := 2;
    end;
   while x > width do
    begin
       if y > depth then exit;
      x := x - width;
      inc(y);
    end;
   if y > depth then exit;
      if width - (x - 1) < length(s) then byte(s[0]) := width - (x - 1);
  p1 := addr(p^.screen^.screen);
   addToDi := ((x-1)*2) + ((y-1) * (p^.width*2)) + borderW; {?}
asm
	push	ds
	mov	cl, s.byte
	xor	ch, ch
	mov	al, TextAttr
	les	di, p1
	mov	dx, ss
	mov	ds, dx
	mov	si, bp
	add	si, offset s + 1
	add	di, addToDi
	jcxz	@exit
@l1:	movsb
	stosb
	loop	@l1
@exit:	pop	ds
end;
end;


Function ToInWindow(n: Word; wind: Word; page: Byte):Word;
var
  x, y, bW:	Word;
  p: WindP;
begin
  GetXYCoordinatesOf(n, x, y, wind, page);
  p := GetWindow(wind, page);
   if p^.op and borderMask <> 0 then bW := 1
   else	bW := 0;
  ToInWindow := (((y-1) + (p^.y-1) + bW) * GetLineLength) + ((x - 1) + p^.x + bW);
end;

Procedure AddToWindCursor(wind: Word; page, num: Byte);
var
  temp, width, depth:	Word;
  p:			WindP;
begin
  p := GetWindow(wind, page);
  temp := num;
  temp := temp + (p^.cx - 1);
   if p^.op and borderMask <> 0 then
    begin
      width := p^.width - 2;
      depth := p^.depth - 2;
    end
    else begin
      width := p^.width;
      depth := p^.depth;
    end;
   while temp > width do
    begin
       if p^.cy < depth then inc(p^.cy);
      temp := temp - width;
    end;
  p^.cx := temp;
end;

Procedure WWrite(x: word; y: Byte; wind: Word; page: Byte; s : String);
var
  width, depth:	Byte;
  p		: WindP;
Label end1;
begin
  p := GetWindow(Wind, page);
  width := p^.width;
  depth := p^.depth;
   if p^.op and BorderMask <> 0 then
    begin
      width := width - 2;
      depth := depth - 2;
    end;
   while x > width do
    begin
      inc(y);
      x := x - width;
    end;
   if p^.screen = nil then UpDataWinPage(page);
   if p^.screen = nil then Exit;
  AddToWindCursor(wind, page, length(s));
   if not writeScroll then
    begin
       if y > depth then Exit;
    end
   else while y > depth do
    begin
      ScrollWindowMem(wind, page);
      dec(y);
    end;
   while s <> '' do
    begin
      WriteWindowMem(x, y, wind, page, Split(s, width - (x - 1)));
       if y < depth then inc(y)
       else begin
	  if writeScroll then ScrollWindowMem(wind, page)
	  else s := '';
       end;
    end;
  UpDateFrom(wind, page);
end;
{*************************End Windows write Procs ***************************}


BEGIN
  windBuf.Init;
  screenBuf.Init;
  SetFrameAttr(TestFrameAttr);
  SetFrameC(TestFrame);
END.