unit _math;

interface
Uses _Buffers, _String, Sysutils, Math, _LongIntegers, _Fractions;

const
  maxOrder = 2;
  OneBitLessThan32 = $7FFFFFFF; //2^31
//  Precision: Integer = 16;
  decimalPoints: Integer = 3;
Type
  st = record
	val:string;
	op:string;
  end;
  MStack = class
//    constructor Create;
    destructor Destroy; override;
    procedure push(val,op:String);
    function GetResult:String;
    function OpLevel(op:String):word;
  private
    { Private declarations }
    stack: array[1..maxOrder+2] of st;
    sp:word;
//    s:String;
    function add(val1,val2:string):String;
    function sub(val1,val2:string):String;
    function divd(val1,val2:string):String;
    function mult(val1,val2:string):String;
    function power(val1,val2:string):String;
    function Calculate(val1,op,val2:string):String;
  public
    { Public declarations }
  end;

function IsReal(s:String):Boolean ; //Must have e or E in it with a number each side, the DecimalSeparator is optional
function IsFloat(s:string):Boolean; //= IsDec or IsReal
function IsFloat2(s:string):Boolean; //= IsDec2 or IsReal
function IsInt(s:string):Boolean;   //A number consisting or 0 to 9 with an optional + or - at the beginning. leading whitespace will be ingnored.
function IsDec(s:string):Boolean;   //IsInt + an optional DecimalSeparator
function IsDec2(s:string):Boolean;  //IsInt + a DecimalSeparator
function IsFrac(s:string):Boolean;

procedure expandNumber(var buf: bufferO; s:String);
procedure addAnswersNumber(var buf: bufferO);	//Add the answers using  a | each string in the buffer
Function _FindAnsswer(s:string):String;//For Bracket support use FindAnsswer
Function FindAnsswer(s:string):String;
Function FindAnsswer2(s:string):String;//strips brackets from ansswer
//Function AddRandNumbers(s: String):String;
function _PreQuestion(s:String):String ;
function PreQuestion(s:String):String ;
Function EvaluateFuncs(s:string):string ;
Function RandBetween(n, n2: Integer):Integer; Overload;
Function RandBetween(s, s2: string):String; Overload;
Function RandBetween(e, e2: extended):extended; overload;
Function CheckFloat(s:String; c:char; n:integer):Boolean; safecall;
//Function GetNextVal(var s:string):String;
Function random(range: extended): extended; overload;
Function random(range: integer): integer; overload;
function GetRanDig():Char ;
Function DeleteExtraWhiteSpace(s:string): String;

Function AddFrac(val1,val2:string):String;
Function AddInt(val1,val2:string):String;
Function AddFloat(val1,val2:string):String;
Function SubFrac(val1,val2:string):String;
Function SubInt(val1,val2:string):String;
Function SubFloat(val1,val2:string):String;
Function DivFrac(val1,val2:string):String;
Function DivInt(val1,val2:string):String;
Function DivFloat(val1,val2:string):String;
Function MulFrac(val1,val2:string):String;
Function MulInt(val1,val2:string):String;
Function MulFloat(val1,val2:string):String;
function powerInt(val1,val2:string):String;
function PowerFloat(val1,val2:string):String;


//The three following functions only work if passed a fraction in the
//form '[int ]int/int' the first int is optional and must be followed
//by a space it is the whole part all of the ints can be a positive
//or negitive integer;
Function GetInt(s:String): String ;
Function GetNumerator(s:String): String ;
Function GetDenominator(s:String): String ;

//The three following functions split off and return the relevant string.
Function GetNextValue(var s:string):String;//The value can be an int, real or decimal
Function GetNextInt(var s:string):String;  //The value can have a - or + but no .
Function GetNextDigits(var s:string):String;//Gets the Digits in [0..9]
Function GetNextFracL(var s: String):String;//Returns the next fraction in the form 123/456 or '' if not found

Function IsIntNext(s:string):Boolean ;
Function NextFracLengthL(s:String):Word ;//returns 0 if no frac next. No whole part.


Function StrToLInt(s:string;base:byte=10):TLongInt ;
Function LIntToHex(n:TLongInt):String ;
Function LIntToStr(n:TLongInt;base:byte=10):String ;	OverLoad;
Function LIntToStr(n:TInt;base:byte=10):String ;	OverLoad;
Function StrHexToLInt(s:string):TLongInt ;
function StrToFrac(s:String):TFrac;
Function FracToStr(f:TFrac):String ;
Function FracToFloatS(s:String):String ;
Function FracToFloat(s:String): Extended;
Function RealToStr(e:Extended):String ;
Function StrToFloat(s:String):Extended;

Function IsGreater(s1,s2:String): Boolean;
Function Compare(const n1:string;n2:LongInt): Integer;overload;
Function Compare(const n1,n2:string): Integer;	   overload;

Function GetLenBase(baseFrom,baseTo,Digits:Integer):Integer ;

implementation

type
  TRandE = array[1..10] of Byte;
  TNTypes = (Str,Ext,Int,LInt,EInt);
  Tnum = record
	   typ:TNTypes;
	   str:String;
	   TInt:TLongInt;
	   ext:Extended;
	   int:Integer;
	   lInt:LongInt;
	 end;
  TVars = record
	    name:string;
	    val:TNum;
	  end;

var
  vars : array of TVars = nil;

Function StrToFloat(s:String):Extended;
Begin
  s := DelAllButK(s,c0To9e+'-');
  if not IsFloat(s) then s := '0';
  result := Sysutils.StrToFloat(s);
end;

Function FindTokon(s:string):integer ;
var
  x:Word;
begin
  for x := 0 to length(vars) - 1 do
  begin
    if vars[x].name = s then
    begin
      result := x+1;
      exit;
    end;
  end;
  result := 0;
end;

Function IsGreater(s1,s2:String): Boolean;
begin
  result := (CompL(StrToLInt(s1).int, StrToLInt(s2).int) = 1);
end;

Function Compare(const n1:string;n2:LongInt): Integer;overload;
begin
  result := CompL(StrToLInt(n1), n2);
end;

Function Compare(const n1,n2:string): Integer;	   overload;
begin
  result := CompL(StrToLInt(n1), StrToLInt(n2));
end;

Function StoreVars(s:String): String;
var
  tokon, value:String;
  x:Word;
begin
  x := InStrPosS(s,':=');
  while x > 0 do
  begin
    tokon := Split2(s,x);
    tokon := DelAllK(tokon,whiteSpace);
    s := DelFirst(s,1);
    value := SplitK3(s,';');
    x := InStrPosS(value,':=');
    if x > 0 then value := copy(value,1,x-1);
    value := FindAnsswer(value);
    if tokon <> '' then
    begin
      x := FindTokon(tokon);
      if x > 0 then
      begin
	vars[x-1].name := tokon;
//	vars[x-1].val := ReturnValue(value);
      end
      else  if value <> '' then
      begin
	SetLength(vars, length(vars) + 1);

      end;
    end;
    x := InStrPosS(s,':=');
  end;
  result := s;
end;


Function IsIntNext(s:String):Boolean ;
var
  x :Word;
begin
  s := DelLeading(s, whiteSpace);
  if InStrAt(s,'+-', 1) then s := DelFirst(s,1);
//  s := DelAllK(s, whiteSpace);
  x := FindFirstNotInK(s,c0To9);
  result := ((x > 1) and (not InStrAt(s,'.eE', x)))
	    or ((x = 0) and (length(s) > 0)) ;
end;


Function FracToStr(f:TFrac):String ;
begin
//  f.whole
  if compLZ(f.denominator) or (compLZ(f.numerator))then
  begin
    //if not compLZ(f.numerator) then error div by 0
    result := LIntToStr(f.whole);
  end
  else if (LengthUsed(f.denominator) = 1) and (f.denominator[0] = 1) then
  begin
    f := MakeImproper(f);
    result := LIntToStr(f.numerator);
  end
  else begin
    if not compLZ(f.whole) then result := LIntToStr(f.whole) + ' ';
    result := result + LIntToStr(f.numerator) + '/';
    result := result + LIntToStr(f.denominator);
  end;
  if (f.sign = -1) and (result <> '0') then result := '-' + result;
end;

function StrToFrac(s:String):TFrac;
var
  t:TLongInt;
begin
  result.sign := 1;
  if not IsFrac(s) then
  begin
    if IsInt(s) then s := s + ' 0/1'
    //else if IsReal the s := RealToFrac() etc. ToDo
    else s := '1/1';
  end;
  t := StrToLInt(GetInt(s));
  result.whole := t.int;
  result.sign := result.sign * t.sign;

  t := StrToLInt(GetNumerator(s));
  result.numerator := t.int;
  result.sign := result.sign * t.sign;

  t := StrToLInt(GetDenominator(s));
  result.denominator := t.int;
  result.sign := result.sign * t.sign;
end;

Function LIntToHex(n:TLongInt):String ;{$WARN UNSAFE_CODE OFF}
var
  L,x,y,z,i :Integer;
  tl:LongWord;
  t:a8Char;
begin  { TODO 5 -ojmnc -cfix error : Wrong order }
  i:=0;
  L := LengthUsed(n.int);
  if l = 0 then
  begin
    result := '';
    exit;
  end;
  tl:= n.Int[l-1];
  if tl <= $FFFFFFF then
  begin
    l := l-1;
    t := _LWToHex(tl);
    while tl > 0 do
    begin
      inc(i);
      tl := tl shr 4;
    end;
    z:=(l*8)+i;
    SetLength(result,z);
    for y := 1 to i do
      result[i-(y-1)] := t[8-y];
  end
  else SetLength(result,l*8);
  for x := l - 1 downto 0 do
  begin
    t := _LWToHex(n.Int[x]);
    for y := 0 to 7 do
      result[y+(((l-1)-x)*8)+i+1] := t[y];
  end;
  if (L > 0) and (n.sign = -1) then result := '-' + result;
  if result = '' then result :='$0';
end; {$WARN UNSAFE_CODE ON}

Function LIntToStr(n:TInt;base:byte=10):String ;
var
  r, L, lB,lN:LongWord;
  x:Integer;
begin   { DONE 5 -ojmnc -cfix error : convert to use base of up to 255 }
  result := '';
  L := LengthUsed(n);
  lB := LengthUsedInBits(n);
  lN := GetLenBase(2,base,lB);
  SetLength(result,lN);
//  if length(n) > L then SetLength(n,L);
  while l > 0 do
  begin
    n := DivIL(n, base, r); {$WARN UNSAFE_CODE OFF}
    result[lN] := NumToC(r,base); {$WARN UNSAFE_CODE ON}
    L := LengthUsed(n);
    dec(lN);
//    if length(n) > L then SetLength(n,L);
  end;
  for x := 1 to Integer(lN) do{$WARN UNSAFE_CODE OFF}
    result[x] := '0';         {$WARN UNSAFE_CODE ON}
  result := DelLeading(result,'0');
  if result = '' then result := '0';
end;


Function LIntToStr(n:TLongInt;base:Byte=10):String ;
begin
  result := LIntToStr(n.int,base);
  if (length(result) > 0) and (n.sign = -1) then result := '-' + result;
end;

Function LettersForBase(base:integer):String ;
//The numbers 0..9 are used for up to base 10
//then uses the letters for upto 36 if more that 36 start at #0
var
  x,l:integer;
begin
  if base = 10 then result := C0to9
  else if base = 16 then result := c0toF
  else if base = 2 then result := '01'
  else if base <= 36 then
  begin
    if base < 10 then
    begin
      setLength(result,base);
      for x := 0 to base-1 do{$WARN UNSAFE_CODE OFF}
	result[x+1] := char($30+x);{$WARN UNSAFE_CODE ON}
    end
    else begin
      result := C0to9;
      l := base+(base-10);
      setLength(Result,l);
      for x := 0 to base-11 do
      begin {$WARN UNSAFE_CODE OFF}
	result[x] := char($41+x);
	result[l-x] := char($61+x);{$WARN UNSAFE_CODE ON}
      end;
    end;
  end
  else begin
    SetLength(result, base);
    {$WARN UNSAFE_CODE OFF}
    for x := 0 to base - 1 do result[x] := char(x);{$WARN UNSAFE_CODE ON}
  end;
end;

Function GetLenBase(baseFrom,baseTo,Digits:Integer):Integer ;
var
  x:Extended;
begin
  x := (ln(baseFrom) / ln(baseTo)) * Digits;	//number of bits
  result := Ceil(x);				//round up;
end;

Function StrToLInt(s:string;base:byte=10):TLongInt ;
var
  len,x:LongWord;
begin
  if instringC(s,'-') then result.sign := -1
  else result.sign := 1;
  s := DelAllButK(s,LettersForBase(base));
  s := DelLeading(s,'0');
  if length(s) = 0 then
  begin
    result.int := nil;
    exit;
  end;
  len := GetLenBase(base, 2, length(s));	//number of bits
  len := DivUp(len,32);		//32 bits in a longword
  SetLength(result.int, len);
  ZeroNL(result.int);
  for x := 1 to length(s) do
  begin
    _MulL(result.int, base,len);
    _AddIAt(result.int,CToNum(s[x]));
  end;
//  SetLength(result.int,LengthUsed(result.Int));
end;

Function StrHexToLInt(s:string):TLongInt ;
var
  L,i,x,y:Integer;
begin
  if instringC(s,'-') then result.sign := -1
  else result.sign := 1;
  DelAllButK(s,c0ToF);
  i := length(s) div 8;
  if (length(s) mod 8) > 0 then
  begin
    inc(i);
  end;
  SetLength(result.int,i);
  l:= length(s);
  for x := 0 to i-1 do
  begin
    y:=(L-(x*8)-8);
    result.int[x] := SHexToLW(s,y);
  end;
end;


procedure AddAnswersNumber(var buf: bufferO);
var
  s,s2:string;
  dP:word;
  x:Integer;
begin
  for x := 1 to buf.Len do
    begin
      s := buf.get(x);
      if (length(s) >= 1) and (s[1] = '$') then
	begin
	  dP := decimalPoints;
	  s := DelFirst(s,1);
	  s := PreQuestion(s);
	  if InStrPosS(s,'//') = 1 then buf.ovr(s, x)
	  else begin
	    s2 := EvaluateFuncs(s);
	    if AllSInK(s2,c0To9e+basicMath+whiteSpace)
	    then buf.ovr(s +'|'+FindAnsswer2(s2), x)
	    else if InStrPosS(s2,'//') = 1 then buf.ovr(s2, x)
	    else buf.ovr('//unexpected error in line:'+s2,x)
	  end;
	  decimalPoints := dP;
	end;
    end;
end;

procedure expandNumber(var buf: bufferO; s:String);
var
  x:word;
  frontOfStr, t, t2, sOld, fromS, outString:String;
  fromN, toN, z, count:Integer;
  buf2:BufferO;
begin
  buf2 := BufferO.Create;
  sOld := s;
  x := InStrPosS(s,'//');
  if x > 0 then s := CopyFirst(s,x-1);
  while instringC(s,'[') do
  begin
    t := Split2(s,FindFirstC(s,'['));
    x := MachingDelimiterPos(s,']');
    if x > 0 then
    begin
      t2 := Split2(s,x);
      t2 := _PreQuestion
      (t2);
      t2 := DelAllK(t2,'[]');
      s := t+t2+s;
    end
    else begin
      s := t+s;
      s := DelAllC(s,'[');
    end;
  end;
  x := FindFirstC(s,'#');
  if x > 0 then
  begin
    if (length(s) > x + 1) then
    begin
      if instringC(c0To9+'-', s[x+1])  then
      begin
	frontOfStr := splitk2(s,'#');
	fromS := SplitLeadingNumberOff(s);
	t := copyFirst(s,2);
	if SUpCase(t) <> 'TO' then
	begin
	  outString := '// The spelling file has errors the keyword "to" was expected on line:'+sOld + ' after:'+frontOfStr + fromS;
//	  outString := frontOfStr + fromS + s;
	  buf2.add(outString);
	end
	else begin
	  s := DelFirst(s,2);
	  toN := StrToNum(SplitLeadingNumberOff(s));
	  fromN := StrToNum(fromS);
	  z := fromN;
	  count := toN;
	  if fromN <= toN then inc(Count)
	  else dec(Count);
	  while z <> Count do
	  begin
	    outString := frontOfStr + IntToStr(z) + s;
	    buf2.add(outString);
	    if fromN <= toN then inc(z)
	    else dec(z);
	  end;
	end;
      end;
    end;
    for x := 1 to buf2.len do
    begin
      t := buf2.Get(x);
      if (InStrPosS(s,'//') = 0) and inString(t,'#')
      then expandNumber(buf,t)
      else buf.Add(t);
    end;
  end
  else if length(s) > 0 then buf.Add(s);
  buf2.Destroy;
end;

Function InStrFuncPos(s,func:string):word;
var
  x:word;
begin
  func := SUpCase(func);
  x := InStrPosS(SUpCase(s), func);
  if x > 0  then
  begin
    if InStrAt(s, char('('), FindFirstNotInK(s, WhiteSpace, x+length(func))) then result := x
    else result := 0;
  end
  else result := 0;
end;

Function GetFuncVal(var s:string; func:string):string;//removes the fuction from s.
var
  v,t:string;
 pos: word;
begin
  pos := InStrFuncPos(SUpCase(s),func);
  if pos > 0  then
  begin
    t := Split(s,pos);
    s := DelFirst(s,length(func));
    s := DelLeading(s, WhiteSpace);
    s := DelFirst(s,1);	//delete "(" bracket this will have been checked before this function is called
    s := DelLeading(s, WhiteSpace);
    pos := MachingDelimiterPos(s,')');
    if pos < 1 then
    begin //rase error
      result :=  '//error function marked with ^ needs ")" ' + t + '^'+func+'('+':'+s;
      exit;
    end;
    v := Split2(s,pos);
    v := EvaluateFuncs(v);
    v := FindAnsswer(v);
    result := v;
    s := t + s;
  end;
end;

Function EvaluateFuncs(s:string):string ;
var
 a:String;
// found: Boolean;
begin
  if InStrFuncPos(s, 'FPoint') > 0  then
  begin
    a := GetFuncVal(s,'FPOINT');
    if (Compare(a,0) >= 0) and (Compare(a,18) = 1) then decimalPoints := StrToInt(a)
    else result := '//error the number of decimal points should be 0 to 18';
  end;
//    else if InStringPosS(SUpCase(s), 'COS(')
//      Begin
//      end;
   result := s;
end;

function _PreQuestion(s:String):String ;
var
 pos: word;
 t,a,b:String;
 found: Boolean;
// ti: Integer;
begin
  found := true;
  repeat
    if InStrPosS(SUpCase(s), 'RAND(') > 0 then
      begin
	pos := InStrPosS(SUpCase(s), 'RAND(');
	t := Split2(s,pos);
	s := DelFirst(s,4);
	s := DelLeading(s, WhiteSpace);
	pos := MachingDelimiterPos(s,':');
	if pos < 1 then
	begin //rase error
	  result :=  '//error rand function marked with ^ needs ":" '+ t + '^RAND(' + s;
	  exit;
	end;
	a := Split2(s,pos);
	a := _PreQuestion(a);
	a := FindAnsswer(a);
	s := DelLeading(s, WhiteSpace);
	pos := MachingDelimiterPos(s,')');
	if pos < 1 then
	begin //rase error
	  result :=  '//error rand function marked with ^ needs ")" ' + t + '^RAND('+a+':'+s;
	  exit;
	end;
	b := Split2(s,pos);
	b := _PreQuestion(b);
	b := FindAnsswer(b);
//        s := DelLeading(s, WhiteSpace);
	s := t + randBetween(a, b) + s;
      end
    else if InStringC(s, '{') then
      Begin
	pos := FindFirstC(s, '{');
	t := Split2(s,pos);
	pos := MachingDelimiterPos(s,'}');
	if pos < 1 then pos := length(s) + 1;
	a := Split2(s,pos);
	// if instringC(a, '{') then rase error
	a := _PreQuestion(a);
	a := FindAnsswer(a);
//        s := DelLeading(s, WhiteSpace);
	s := t + a + s;
      end
    else found := false;
  until found = false;
  result := s;
end;

function PreQuestion(s:String):String ;
var
  t,a:String;
  pos:word;
begin
  if InStringC(s, '{') then
  Begin
    pos := FindFirstC(s, '{');
    t := Split2(s,pos);
    pos := MachingDelimiterPos(s,'}');
    if pos < 1 then pos := length(s) + 1;
    a := Split2(s,pos);
    if InStringC(s, '{') then s := PreQuestion(s);
    a := _PreQuestion(a);
    if (length(DelLT(t, WhiteSpace)) = 0) and (length(DelLT(s, WhiteSpace)) = 0) then s := FindAnsswer(a)
    else s := t + FindAnsswer(a) + s;
  end;
  result := _PreQuestion(s);
end;

Function CheckFloat(s:String; c:char; n:integer):boolean; safecall;
begin
  if not InStringC(c0To9+#8+'.eE',c) then result := false
  else if (inStringC(s,'.')) and (c='.') then result := false
  else if (inString(s,'eE')) and (inStringC('eE',c)) then result := false
  else result := true;
end;

function IsInt(s:string):Boolean;
var
  maxCount:word;
begin
  s := DelLeading(s, WhiteSpace);
  if InStrAt(s,'+-',1) then maxCount := 1 else maxCount := 0;
  if (InStrCount(s,'-+') <= maxCount)
    and InString(s, c0To9)
    and AllSInK(s, c0To9+'-+')
  then result := True
  else result := False;
end;

function IsFloat(s:string):Boolean;
begin
  result := IsDec(s) or IsReal(s);
end;

function IsFloat2(s:string):Boolean;
begin
  result := IsDec2(s) or IsReal(s);
end;

function IsDec2(s:string):Boolean;
begin
  result := IsDec(s) and InString(s, DecimalSeparator);
end;

function IsDec(s:string):Boolean;
begin
  if (InStrCount(s, char(DecimalSeparator)) = 1)
    and K2NotBeforeK1(s,'+-', DecimalSeparator)
  then s := DelAllC(s, DecimalSeparator);
  result := IsInt(s);
end;

Function GetInt(s:String): String ;
begin
  Result := CopyTo(s,' ',True , False)
end;

Function GetNumerator(s:String): String ;
begin
  if inStringC(s,' ') then Result := CopyFromTo(s,' ', '/',True , False)
  else Result := CopyTo(s, '/',True , False);
end;

Function GetDenominator(s:String): String ;
begin
  Result := CopyFrom(s, '/',True , False);
end;

Function IsFrac(s:String): Boolean ;
var
  int, denominator, numerator :string;
begin
  if InStringC(s,' ') then int := Split2(s,FindFirstC(s,' '))
  else int := '';
  if InStringC(s,'/') then numerator := Split2(s,FindFirstC(s,'/'))
  else numerator := '';
  denominator := s;
  result :=  ((int = '') or IsInt(int))
	     and IsInt(numerator)
	     and IsInt(denominator)
end;

function IsReal(s:String):Boolean ; //Must have e or E in the string
var
  m :String;
begin
  if InStrCount(s,'eE') <> 1 then Result := false
  else begin
    m := SplitK2(s,'eE');
    result := IsDec(m) and IsInt(s)
  end;
end;


Function RandBetween(s, s2: string):String; overload;
var
  n1, n2: Integer;
  e1,e2:Extended;
begin
  if IsInt(s) then
    begin
      n1 := StrToInt(s);
      n2 := StrToInt(s2);
      result := IntToStr(RandBetween(n1,n2));
    end
  else if IsReal(s) then
    begin
      e1 := StrToFloat(s);
      e2 := StrToFloat(s2);
      result := FloatToStr(RandBetween(e1,e2));
    end
  else begin
    result := '';
{ TODO 5 : error }    // rase error
  end;
end;

Function RandBetween(n, n2: integer):integer; overload;
var
  nt, range: Integer;
begin
  if n > n2 then
    begin
      nt := n;
      n := n2;
      n2 := nt;
    end;
  range := n2 - n;
  nt := random(range + 1);
  result := nt + n;
end;

Function random(range: extended): extended; overload;
var
  sRange, sResult: String;
  x,t1,t2:Byte;
  c:Boolean;
begin
  sRange := FloatToStr(range);
  c := true;
  SetLength(sResult,length(sRange));
  for x := 1 to length(sRange) do
  begin
    if InStringC(c0To9,sRange[x]) then
    begin
      if c then
      begin
	t1 := StrToInt(sRange[x]);
	t2 := Random(t1);{$WARN UNSAFE_CODE OFF}
	sResult[x] := IntToStr(t2)[1];
	if t1 > t2 then c := False;
      end
      else sResult[x] := GetRanDig;
    end
    else begin
      sResult[x] := sRange[x];
      if sRange[x] = 'E' then c := True;{$WARN UNSAFE_CODE ON}
    end;
  end;
  result := StrToFloat(sResult);
end;

Function random(range: integer): integer; overload;
begin
  result := system.random(range);
end;

Function RandBetween(e, e2: extended):extended; overload;  //asm
var
  nt, range: extended;
begin
  if e > e2 then
    begin
      nt := e;
      e := e2;
      e2 := nt;
    end;
  range := e2 - e;
  nt := random(range + 1);
  result := nt + e;
end;

function GetRanDig():Char ;
begin
  result := intToStr(system.random(9))[1];
end;

{ TODO 5 -ojmnc -cMath : sort out the whitespace }
Function InsX(s:String): String;
var
  x:Word;
begin
  if instring(s,'()') then
    begin
      x:=1;
      while x <= length(s) do
	begin
	  if (x > 1)
	  and (s[x] = '(')
	  and (InStringC(c0to9, s[x-1]))
	  then Insert('x', s, x)
	  else if (x < length(s))
	  and (s[x] = ')')
	  and InStringC(c0to9+'(', s[x+1])
	  then Insert('x', s, x+1);
	  inc(x);
	end;
      result := s;
    end
    else result := s;
end;

Function ExpandBracket(s:string):String;
Function XBSub(var s:String):String;
var
  t,a,b:string;
begin
  t := splitK2(s, '(');
  if InString(s,'(') then //Check for more openning brackts
  begin
    b := XBSub(s);
    a := SplitK3(b, ')');
    a := _FindAnsswer(a);
    t := a + b;
  end
  else  t := t + _FindAnsswer(SplitK3(s, ')') ) + s;
  result := t;
end;
begin
  s := DeleteExtraWhiteSpace(s);
  if InString(s,'()') then
    begin
      s := InsX(s);		//insert the x between brakets
      result := XBSub(s);
    end
  else result := s;
//  if InString(result,')')
//    then result := DelAllK(result,')');
//  if InString(result,'(')
//    then{ TODO 5 : Rase error } ;

end;

Function GetNextOperand(var s:string):String;
var
  x: Word;
begin
  if Length(s) = 0 then result := ''
  else begin
    x:=0;
    while
      (length(s) > x)
      and
      (
	(InStringC(basicMath,s[x+1]) and  (x=0))
	or
	(InStringC(AToz,s[x+1]))
      )
    do inc(x);
    result := split(s,x);
  end
end;

Function GetNextFracL(var s: String):String ;
var fl:Word;
begin
  fL := NextFracLengthL(s);
  if fL > 0 then result := Split(s,fL)
  else result := '';
end;


Function GetNextDigits(var s:string):String;
var
  x:word;
begin
  x:=0;
  while (length(s) > x) and (InStringC(c0To9,s[x+1]) ) do inc(x);
  result := split(s,x);
end;

Function GetNextInt(var s:string):String;
begin
  result := '';
  s := DelLeading(s,whiteSpace);
  if Length(s) = 0 then result := ''
  else begin
    if s[1] in ['-','+'] then result := split(s,1);
    result := result + GetNextDigits(s);
  end
end;

Function GetNextValue(var s:string):String;
//must of had extra white space removed or fractions will be messed up
var
  pos :word;
  t: string;
begin
  if InStrAt(s,'(',1) then
  begin
    s := DelFirst(s,1);
    pos := MachingDelimiterPos(s,')');
    result := split2(s,pos);
    if IsFrac(result) then
    begin
      if inStringC(result,' ') then t := GetNextInt(result);
      result := t + GetNextFracL(result);
    end
    else result := GetNextValue(result);
  end
  else begin
    result := GetNextInt(s);
    if length(s) >= 1 then
      if s[1] = '.' then
      begin
	result := result + split(s,1);
	result := result + GetNextDigits(s);
      end;
    if length(s) > 1 then
      if InStrAt(s,'eE',1) and (InStrAt(s,c0to9, 2)) then
      begin
	result := result + split(s,1);
	result := result + GetNextDigits(s);
      end;
    if InStrAt(s,' ',1) then Result := result + GetNextFracL(s);
  end;
end;


{duplacated Function EvaluateFunctions(s: string):String;
var
  found : Boolean;
Begin
  found := true;
  repeat
    if InStrPosS(SUpCase(s), 'RAND(') > 0 then
      begin
      end
    else if InStrPosS(SUpCase(s), 'SIN(') > 0 then
      Begin
      end
    else if InStrPosS(SUpCase(s), 'COS(') > 0 then
      Begin
      end
    else found := false;
  until found = false;
end;}

Function NextFracLengthL(s:String):Word ;
var
  l: Word;
begin
  l := length(s);
  result := 0;
  if IsIntNext(s) then
  begin
    GetNextInt(s);
    s:= DelLeading(s,whiteSpace);
    if InStrAt(s, '/', 1) then
    begin
      s := DelFirst(s,1);
      if IsIntNext(s) then
      begin
	GetNextInt(s);
	result := l - length(s);
      end;
    end;
  end
end;


Function DeleteExtraWhiteSpace(s:string): String;
var
  fl		:word;
  outStr	:String;
begin
  s := DelLT(s,whiteSpace);
  if not InStringC(s,'/') then outStr := DelAllK(s,whiteSpace)
  else if not InString(s,whiteSpace) then outStr := s
  else begin
    outStr := '';
    while length(s) > 0 do
    begin
      outStr := outStr + Split2(s,FindFirstK(s, whiteSpace));
      fL := NextFracLengthL(s);
      if (fL > 0)
      and (InStrAt(outStr,c0to9,length(outStr)))
      then outStr := outStr + ' ' + DelAllK(Split(s,fL), whiteSpace);
      s := DelLeading(s, whiteSpace);
      if not InString(s,whiteSpace) then
      begin
	outStr := outStr + s;
	s := '';
      end;
    end;
  end;
  result := outStr;
end;

Function _FindAnsswer(s:string):String;//For Bracket support use FindAnsswer
//This function is needed to prevent infinite recursion in expandbracket as brackets are used to enclose fractions while computing the ansswer.
var
  val,operand,sTemp: String;
  stack: MStack;
begin
  stack := MStack.Create;
  result := '';
  sTemp := s;
  while length(sTemp) > 0 do
    begin
      val := GetNextValue(sTemp);
      if val = '' then
      begin
	result := ('//Error unexpected character in"'+s+'" at:' + sTemp);
	sTemp := '';
      end;
      if length(sTemp) > 0 then operand := GetNextOperand(sTemp)
      else operand := '';
      stack.push(val,operand);
    end;
  if not CompTo(result,'//Error',7) then
  begin
    result := stack.GetResult;
    if IsFrac(result) then result := '(' + result + ')';
  end;
  stack.Destroy;
end;

Function FindAnsswer2(s:string):String;
begin
  s := FindAnsswer(s);
  if InString(s,'()') then
    s := DelAllK(s,'()');//remove any brackets enclosing a fraction
  result := s;
end;

Function FindAnsswer(s:string):String;
begin
  s := StoreVars(s);
  s := ExpandBracket(s);
  s := _FindAnsswer(s);
  result := s;
end;

destructor MStack.Destroy;
var
  x: Integer;
begin
  for x := 1 to maxOrder do
  begin
    stack[x].val := '';
    stack[x].op := '';
  end;
  Inherited Destroy;
end;

function MStack.OpLevel(op:String):word;
begin
  if op = '' then result := 0
  else if (length(op) = 1) and (inString('-+', op)) then result := 1
  else if (length(op) = 1) and (inString('*/x', op)) then result := 2
  else if (length(op) = 1) and (inString('^', op)) then result := 3
  else result := 4;
end;

function MStack.Add(val1,val2:string):String;
// Expecs two numbers not functions etc.
begin
  if IsInt(val1) and IsInt(val2)
  then result := AddInt(val1,val2)
  else if IsFloat(val2)// and (IsInt(val1) or IsFloat(val1) or IsFrac(val1)))
       or IsFloat(val1)// and (IsInt(val2) or IsFloat(val2) or IsFrac(val2)))
  then result := AddFloat(val1, val2)
  else if IsFrac(val1) and (IsFrac(val2) or IsInt(val2))
       or IsFrac(val2) and (IsFrac(val1) or IsInt(val1))
  then result := AddFrac(val1,val2);
end;

function MStack.Sub(val1,val2:string):String;
begin
  if IsInt(val1) and IsInt(val2) then result := SubInt(val1,val2)
  else if IsFloat(val1) or IsFloat(val2) then result := SubFloat(val1, val2)
  else if IsFrac(val1) and (IsFrac(val2) or IsInt(val2))
       or IsFrac(val2) and (IsFrac(val1) or IsInt(val1))
  then result := SubFrac(val1,val2)
  else result := '1';	//error
end;

function MStack.divd(val1,val2:string):String;
begin
  if IsInt(val1) and IsInt(val2)
  then result := DivInt(val1,val2)
  else if IsFloat2(val2) or IsFloat2(val1) then
    result := DivFloat(val1, val2)
  else if IsFrac(val1) and (IsFrac(val2) or IsInt(val2))
       or IsFrac(val2) and (IsFrac(val1) or IsInt(val1))
  then result := DivFrac(val1,val2);
end;

function MStack.Power(val1,val2:string):String;
begin
  if IsInt(val1) and IsInt(val2)
  then result := PowerInt(val1,val2)
  else if IsReal(val1) or IsReal(val2) or IsDec2(val1) or IsDec2(val2)
    then result := PowerFloat(val1, val2);
//  else if IsFrac(val1) and (IsFrac(val2) or IsInt(val2))
//       or IsFrac(val2) and (IsFrac(val1) or IsInt(val1))
//    then result := MulFrac(val1,val2);
{ TODO -ojmnc -cunfinished : Add Fractions support }
end;

function MStack.mult(val1,val2:string):String;
begin
  if IsInt(val1) and IsInt(val2)
  then result := MulInt(val1,val2)
  else if IsReal(val1) or IsReal(val2) or IsDec2(val1) or IsDec2(val2)
    then result := MulFloat(val1, val2)
  else if IsFrac(val1) and (IsFrac(val2) or IsInt(val2))
       or IsFrac(val2) and (IsFrac(val1) or IsInt(val1))
    then result := MulFrac(val1,val2);
end;

function MStack.Calculate(val1,op,val2:string):String;
begin
  if op = '-' then result := Sub(val1,val2)
  else if op = '+' then result := add(val1,val2)
  else if op = '/' then result := divd(val1,val2)
  else if (op = '*') or (op = 'x') then result := mult(val1,val2)
  else if (op = '^') then result := power(val1,val2)
  else result := mult(val1,val2);
end;

procedure MStack.push(val,op:String);
begin
  inc(sp);
  stack[sp].val := val;
  stack[sp].op := op;
  while (sp > 1)
  and (OpLevel(stack[sp-1].op) >= OpLevel(stack[sp].op)) do
    begin
      stack[sp-1].val := Calculate(stack[sp-1].val,stack[sp-1].op,stack[sp].val);
      stack[sp-1].op := stack[sp].op;
      dec(sp);
    end;
end;

function MStack.GetResult:String;
begin
  if sp = 1 then result := stack[sp].val
  else result := '';
end;

function AddInt(val1,val2:string):String;
var
  i1,i2,i3: TLongInt;
begin
  i1 := StrToLInt(val1);
  i2 := StrToLInt(val2);
  i3 := AddI(i1,i2);
  result := LIntToStr(i3);
end;

function AddFrac(val1,val2:string):String;
var
  f1,f2 :TFrac;
begin
  f1 := StrToFrac(val1);
  f2 := StrToFrac(val2);
  f1 := AddFracF(f1, f2);
  result := FracToStr(f1);
end;

Function FracToFloatS(s:String):String ;
begin
  result := FloatToStr(FracToFloat(s));
end;

Function FracToFloat(s:String): Extended ;
var
  i,n,d:Extended;
  t : String;
begin
  t := GetInt(s);
  if IsInt(t) then i := StrToFloat(t)
  else i:=0;
  t := GetNumerator(s);
  if IsInt(t) then n := StrToFloat(t)
  else n := 0;
  t := GetDenominator(s);
  if IsInt(t) then d := StrToFloat(t)
  else d:=1;
  if d = 0 then d := 1; //error

  n := n + i*d;		// add in the whole part
  i := n / d;
  result := i;
end;

function AddFloat(val1,val2:string):String;
var
  va1, va2: Extended;
begin
  if (IsFloat(val1) or IsInt(val1)) then va1 := StrToFloat(val1)
  else if IsFrac(val1) then va1 := FracToFloat(val1)
  else va1 := 1.0;

  if (IsFloat(val2) or IsInt(val2)) then va2 := StrToFloat(val2)
  else if IsFrac(val2) then va2 := FracToFloat(val2)
  else va2 := 1;

  result := RealToStr(va1 + va2);
end;

function SubInt(val1,val2:string):String;
var
  i1,i2,i3: TLongInt;
begin
  i1 := StrToLInt(val1);
  i2 := StrToLInt(val2);
  i3 := SubI(i1,i2);
  result := LIntToStr(i3);
end;

function SubFrac(val1,val2:string):String;
var
  f1,f2 :TFrac;
begin
  f1 := StrToFrac(val1);
  f2 := StrToFrac(val2);
  f1 := SubFracF(f1, f2);
  result := FracToStr(f1);
end;

function SubFloat(val1,val2:string):String;
var
  va1, va2: Extended;
begin
  if (IsFloat(val1) or IsInt(val1)) then va1 := StrToFloat(val1)
  else if IsFrac(val1) then va1 := FracToFloat(val1)
  else va1 := 1;

  if (IsFloat(val2) or IsInt(val2)) then va2 := StrToFloat(val2)
  else if IsFrac(val2) then va2 := FracToFloat(val2)
  else va2 := 1;

  result := RealToStr(va1 - va2);
end;

function DivInt(val1,val2:string):String;
var
  i1,i2: TLongInt;
  f:TFrac;
begin
  i1 := StrToLInt(val1);
  i2 := StrToLInt(val2);
  f := DivF(i1,i2);
  result := FracToStr(f);
end;

function DivFrac(val1,val2:string):String;
var
  f1,f2 :TFrac;
begin
  f1 := StrToFrac(val1);
  f2 := StrToFrac(val2);
  f1 := DivFracF(f1, f2);
  result := FracToStr(f1);
end;

function DivFloat(val1,val2:string):String;
var
  va1, va2: Extended;
begin
  if (IsFloat(val1) or IsInt(val1)) then va1 := StrToFloat(val1)
  else if IsFrac(val1) then va1 := FracToFloat(val1)
  else va1 := 1;

  if (IsFloat(val2) or IsInt(val2)) then va2 := StrToFloat(val2)
  else if IsFrac(val2) then va2 := FracToFloat(val2)
  else va2 := 1;

  result := RealToStr(va1 / va2);
end;

function MulInt(val1,val2:string):String;
var
  i1,i2,i3: TLongInt;
begin
  i1 := StrToLInt(val1);
  i2 := StrToLInt(val2);
  i3 := MulI(i1,i2);
  result := LIntToStr(i3);
end;

function powerInt(val1,val2:string):String;
var
  i1,i2,i3,x: TLongInt;
begin
  i1 := StrToLInt(val1);
  i2 := StrToLInt(val2);
  i3 := i1;
  x := i2;
  if not CompLZ(x.int) then DecI(x);
  while not CompLZ(x.int) do
  begin
    i3 := MulI(i3,i1);
    DecI(x);
  end;
  if i2.sign < 1 then
  begin
    result := '1/'+LIntToStr(i3);
  end
  else result := LIntToStr(i3);
end;

function PowerFloat(val1,val2:string):String;
var
  va1, va2: Extended;
begin
  if (IsFloat(val1) or IsInt(val1)) then va1 := StrToFloat(val1)
  else if IsFrac(val1) then va1 := FracToFloat(val1)
  else va1 := 1;

  if (IsFloat(val2) or IsInt(val2)) then va2 := StrToFloat(val2)
  else if IsFrac(val2) then va2 := FracToFloat(val2)
  else va2 := 1;

  result := RealToStr(math.power(va1, va2));
end;

function MulFrac(val1,val2:string):String;
var
  f1,f2 :TFrac;
begin
  f1 := StrToFrac(val1);
  f2 := StrToFrac(val2);
  f1 := MulFracF(f1, f2);
  result := FracToStr(f1);
end;

Function RealToStr(e:Extended):String ;
begin
  result := FloatToStrF(e,ffFixed,18,decimalPoints);
  if InStringC(result, DecimalSeparator) then
    result := DelTrailing(result,'0');
end;


function MulFloat(val1,val2:string):String;
var
  va1, va2: Extended;
begin
  if (IsFloat(val1) or IsInt(val1)) then va1 := StrToFloat(val1)
  else if IsFrac(val1) then va1 := FracToFloat(val1)
  else va1 := 1;

  if (IsFloat(val2) or IsInt(val2)) then va2 := StrToFloat(val2)
  else if IsFrac(val2) then va2 := FracToFloat(val2)
  else va2 := 1;

  result := RealToStr(va1 * va2);
end;


var
  n1,n2, n3, n4, n5, n6: TLongInt;
  s,s2:String;
  x:Longword;
begin
  Randomize;
  //test
  {$WARN UNSAFE_CODE OFF}
  setLength(s,4);
  x := SHexToLW('Fe0dc');
  longword(addr(s[1])^) := x;
  n1 := StrHexToLInt('122387a0798bf987a0879fd87963e1784eeffaabb11c0000000000');
  n2 := StrHexToLInt('12387a89f87978aabb');
  n3.int := n2.int;
  n4.int := DivL(n1.int,n2.int);
  n3.int := MulL(n1.int,n2.int);
  n4.int := DivL(n3.int,n2.int);
  n4.int := DivL(n3.int,n1.int);
  s := LIntToStr(n1,16);
  s2 := LIntToHex(n1);
  n2 := StrToLInt('122387a0798bf987a0879fd87963e1784eeffaabb11c0000000000',16);
  s := LIntToStr(n2,16);
  n1 := StrHexToLInt('fffffffF000');
  s := LIntToHex(n1);
  s := LIntToStr(n1,16);

  s:=FormatFloat('#0.###', 1.423);
  s2:=FormatFloat('#0.###', 1.4237);
  s:=FormatFloat('#0.###', 1.4232);
  s2:=FormatFloat('#0.###', 123432.423);
  s:=FormatFloat('#0.###', 0.00423);
  s:=FormatFloat('#0.###', 0.0000423);
  s:=FormatFloat('#0.###', 0.5);

  s := FindAnsswer('12798374983748/8324798327');
  GetRanDig();
  GetRanDig();
  SetLength(n1.int,3);
  SetLength(n2.int,3);
  n1.sign := 1;
  n2.sign := 1;
  n1.int[0] := $ffffffff;
  n1.int[1] := $ffffffff;
  n1.int[2] := $ffff;
  n2.int[0] := $77777777;
  n2.int[1] := $77777777;
  n2.int[2] := $7777;
  n3 := MulI(n1,n2);
  setlength(n3.int,5);
  n5 := DivI(n3,n2,n6);
  s := LIntToStr(n3);
  n5 := DivI(n3,n2,n6);
  n5 := DivI(n3,n1,n6); //error
  n6 := StrToLInt(s);
  n5 := DivI(n6,n2,n6);
  n3 := AddI(n3,n2);
  n5 := DivI(n3,n2,n6);
  n5 := DivI(n3,n1,n6);

  s := LIntToStr(n3);
  n2.int[0] := $FFFFFFFF;
  s := LIntToStr(n2);
  n2.int[0] := $FF;
  s := LIntToStr(n2);
  n1.int[0] := 0;
  n1.int[1] := 1;
  n1.sign := -1;
  s := LIntToStr(n1);
  s := FloatToStr(0.01e100);
  setLength(s,0);
end.


