{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,R+,S+,V+,X-}
Unit _Menus;
Interface

Uses Crt, _Dos, _Screen, _Win2, _KeyB, _String, _Buffers, _Num;

Const
  menuPos:		Byte = 1;
  repeatMenu:		Boolean = False;
  highlightAttr:	Byte = RedB;
Var
  MenuBar	: BufferO;

Procedure Bar(x,y,length:Byte);
Function BarCursor2(x1,length,top,bot,start:Byte; s:String):Word;
Function Menu(x, y, page : Byte; var buf : BufferO):Word;

IMPLEMENTATION
Const
  {MenuBar : Array[1..16] of String[80] = ('','','','','','','','','','','','','','','','');}
  helpBarLine	: Byte = 23;
  helpBarLength	: Byte = 78;
  helpBarBackGround:	Char = '#';

Procedure Bar(x, y, length : Byte); Assembler;
const
  t		: Word = 0;
  stopPos	: Word = 0;
asm
  cmp	length, 0
  je	@end                    {if length = 0 then exit}
  sub	ax, ax
  push	ax
  push	ax
  call	windwidth		{if x>windwidth then x:=windwidth;}
  cmp	x, al
  jna	@s1
  mov	x, al
@s1:
  sub	ax, ax
  push	ax
  push	ax
  call	winddepth		{if y>winddepth then y:=winddepth;}
  cmp	y, al
  jna	@s2
  mov	y, al
@s2:
  sub	ax, ax
  push	ax
  push	ax
  call	windwidth		{if x+length > windwidth then}
  mov	bl, x
  add	bl, length
  dec	bl
  cmp	bl, al
  jna	@s3
  inc	al
  sub	al, x			{length := windwidth - x;}
  mov	length, al
@s3:
  mov	al, x
  xor	ah, ah
  mov	t, ax
  and	stopPos, 0
  sub	ax, ax
  push	ax
  push	ax
  call	windWidth		{t := t + ((y - 1) * GetLineLength);}
  mov	bl, y
  dec	bl
  mul	bl
  add	ax, t
  push	ax
  sub	ax, ax
  push	ax
  push	ax
  call	ToInWindow		{t := ToInWindow(t);}
  mov	t, ax

{  mov ax,t			{  for n:=t to t+length-1 do }
  shl ax,1			{  s^[n].attr:=(s^[n].attr xor $77); }
  dec ax
  push	ax			{ optimised version of ^ }
  call	GetVideoSegment		{s := ptr(GetVideoSegment, GetPageOffset);}
  push	ax
  call	GetPageOffset
  mov	di, ax
  pop	es
  pop	ax
  add	di, ax
  sub cx,cx
  mov cl,length
  mov ax,$77
@l1:
  xor [es:di],ax
  inc di
  inc di
  loop @l1
@end:
end;

Function BarCursor2(x1, length, top, bot, start : Byte; s : String ) : Word;
var
  k	: key;
  k2	: Char;
  pos	: Byte;
  temp, x3	: Word;
  tempS,aString	: String;
  cursorSave:	Byte;

Procedure HelpBar; Assembler;
asm
  pop	si
  push	si
  push	ss
  mov	di, si
  add	di, offset tempS
  push	di
  mov	al, helpBarBackGround
  push	ax
  push	helpBarLength.word(0)
  call	StringOf
  add	sp, 4
  push	helpBarLine.word(0)	{CenterLine(helpBarLine, MenuBar.Get(pos));}
  push	ss
  mov	di, si
  add	di, offset tempS
  push	di
  call	CenterLine
  pop	si
  push	si
  push	ss
  mov	di, si
  add	di, offset tempS
  push	di
  xor	ax, ax
  mov	al, [ss:si+offset pos.word(0)]
  push	ax
  mov	ax, seg MenuBar
  push	ax
  mov	ax, offset MenuBar
  push	ax
  call	_Buffers.BufferO.Get
  add	sp, 4
  pop	si
  push	si
  push	helpBarLine.word(0)	{CenterLine(helpBarLine, StringOf('', helpBarLength));}
  push	ss
  mov	di, si
  add	di, offset tempS
  push	di
  call	CenterLine
  pop	bp
  ret
end;

BEGIN
  cursorSave := GetCursorAttr;
  SetCursorAttr(Invisable);
asm
  call	UpdateCursor		{UpdateCursor;}
  mov	al, top
  mov	ah, bot
  mov	cl, start
  cmp	ah, al			{if bot < top then bot := top;}
  jnb	@s1
  mov	bot, al
  mov	ah, al
@s1:
  cmp	cl, ah			{if start > bot then start := bot;}
  jna	@s2
  mov	start, ah
  mov	cl, ah
@s2:
  cmp	cl, al			{if start < top then start := top;}
  jnb	@s3
  mov	start, al
  mov	cl, al
@s3:
  mov	pos, cl			{pos := start;}
  push	ss			{s := SUpCase(s);}
  mov	di, bp
  add	di, offset s
  push	di
  push	ss
  mov	di, bp
  add	di, offset s
  push	di
  call	SUpCase
  add	sp, 4
(*  push	x1.word(0)		{Bar(x1, start, x2 - (x1 - 1));}
  push	start.word(0)
  mov	al, x1
  dec	al
  mov	bl, x2
  sub	bl, al
  push	bx
  call	Bar*)
end;
  x3 := XYToInWindowN(x1, start, 0, 0);
  aString := GetAttrStr(x3, 0, 0, length);
  DWriteAttr(x3, 0, 0, length, highlightAttr);
asm
  call	HelpBar;
end;
    repeat
asm
  push	ss			{k := KeyLoop;}
  mov	di, bp
  add	di, offset k
  push	di
  call	KeyLoop
  add	sp, 4
  push	k.word(1)		{k2 := UpCase(k[1]);}
  call	UpCase
  mov	k2, al
  cmp	k.Byte(0), 2		{if k = up then dec(pos)  else}
  jne	@e1
  cmp	k.Word(1), $4800
  jne	@s4
  dec	pos
  jmp	@e1
@s4:
  cmp	k.Word(1), $5000	{if k = Down then Inc(pos) else}
  jne	@e2
  inc	pos
@e1:
  mov	tempS.Byte, 1		{if InString(s,k2) then pos := InStringPos(s,k2);}
  mov	bl, k2
  mov	tempS.Byte(1), bl
  push  ss
  mov	di, bp
  add	di, offset s  {asm}
  push	di
  push  ss
  mov	di, bp
  add	di, offset tempS
  push	di
  call	InString
  cmp	al, 0
  je	@s5
  mov	tempS.Byte, 1
  mov	al, k2
  mov	tempS.Byte(1), al
  push	ss
  mov	di, bp
  add	di, offset s  {asm}
  push	di
  push  ss
  mov	di, bp
  add	di, offset tempS
  push	di
  call	InStringPos
  mov	pos, al
@s5:
  mov	al, bot			{if pos > bot then pos := top else}
  mov	ah, top
  cmp	pos, al
  jna	@s6
  mov	pos, ah
  jmp	@e2
@s6:
  cmp	pos, ah			{if pos < top then pos := bot;}
  jnb	@e2
  mov	pos, al
@e2:
end;
  x3 := XYToInWindowN(x1, start, 0, 0);
  WriteAttrS(x3, 0, 0, aString);
  aString := GetAttrStr(x3, 0, 0, length);
  x3 := XYToInWindowN(x1, pos, 0, 0);
  DWriteAttr(x3, 0, 0, length, highlightAttr);

asm
(*push	x1.word(0)		{Bar(x1, start, x2 - (x1 - 1));}
  push	start.word(0)
  mov	al, x2
  sub	al, x1
  inc	al
  push	ax
  call	Bar
  push	x1.word(0)		{Bar(x1, pos, x2 - (x1 - 1));}
  push	pos.word(0)
  mov	al, x2
  sub	al, x1
  inc	al
  push	ax
  call	Bar*)
  call	HelpBar;
  mov	al, pos			{start := pos;}
  mov	start, al
end
    Until((InString(s,k2) = True)or(k = esc)or(k = ret)or(k=left)or(k=Right));
   if InString(s,k[1]) or (k = left) or (k = right) then
    begin
      x3 := XYToInWindowN(x1, start, 0, 0);
      WriteAttrS(x3, 0, 0, aString);
    end;
   if InString(s,k[1]) then BarCursor2 := pos
   else if k = Esc then BarCursor2 := 0
   else if (k = left) or (k = right) then
    begin
       if k = left then temp := 256 else
      temp := 512;
      temp := temp + pos;
      BarCursor2 := temp;
    end
   else BarCursor2 := pos;
  SetCursorAttr(cursorSave);
  UpdateCursor;
end;

Function Menu(x, y, page : Byte; var buf : BufferO):Word;
Var
  Width, Depth:			Byte;
  buf2, buf3:			BufferO;
  f, e:				Word;
  hotKeys, pos, heading:	String;
  temp:				Boolean;
  code:				Integer;
begin
  InOutZ;
  Menu := 0;
   if buf.Len < 3 then begin InOut(570, 13, 295); exit; end;
  depth := RoundUp((buf.Len - 4) / 2);
  buf2.Init;
  buf3.Init;
  hotKeys := buf.Get(1);
  pos := buf.Get(2);
  heading := buf.Get(3);
  f := 4;
   While f - 4 <= depth * 2 do
    begin
      buf2.add(buf.Get(f));
      inc(f);
      buf3.add(buf.get(f));
      inc(f);
    end;
{  f := SaveBuffer(buf2, 'con');
  f := SaveBuffer(buf3, 'con');}
   if not repeatMenu then
    begin
      width := Length(buf2.Get(buf2.Longest));
      e := MakeWindow(x, y, width, depth, page, heading);
      {$IfNDef NoErrorCheck}
       if InOutError then
	begin
	  {$IfNDef NoErrorTrace}
	   TraceError(U_Win2, 124);
	  {$EndIf}
	  exit;
	end;
       {$EndIf}
      fillC := '*';
      temp := writeScroll;
      writeScroll := False;
       for f := 1 to depth do
	begin
	  WWrite(1, f, 0, 0, buf2.Get(f) );
	   if InOutError then begin InOut(e, 13, 331); Exit; end;
	end;
      writeScroll := temp;
      Val(pos, f, code);
    end
    else begin
      f := menuPos;
      repeatMenu := False;
    end;
  MenuBar.Concat(buf3);
  if code <> 0 then begin InOut(571, 13, 341); Exit; end;
  Menu := BarCursor2(1, width, 1, depth, f, hotKeys);
  buf2.Done;
  buf3.Done;
  MenuBar.Done;
end;

BEGIN
  MenuBar.Init;
  helpBarLine := GetScreenRows - 2;
END.