unit MakeWrongwordFile;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, _ScoreUtils2, IBStoredProc, IBCustomDataSet, DB, IBQuery,
  IBDatabase, ComCtrls, StdCtrls, Buttons, Grids, DBGrids, ExtCtrls, Spin;

type
  TSU1 = class(TSU)
    Panel1: TPanel;
    Label4: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Label5: TLabel;
    CountG: TCheckBox;
    SpinEdit1: TSpinEdit;
    CountL: TCheckBox;
    SpinEdit2: TSpinEdit;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure updateUserList(Sender: TObject);
    procedure CountGClick(Sender: TObject);
    procedure CountLClick(Sender: TObject);
    procedure CountClick(Sender: TObject);
    procedure SpinEdit1Change(Sender: TObject);
    procedure ShowCurrentUserClick(Sender: TObject);
    procedure ShowAllUserClick(Sender: TObject);
    procedure PickFromListClick(Sender: TObject);
    procedure UserListChange(Sender: TObject);
  private
    { Private declarations }

  public
    function CreateSql():String; override ;
    { Public declarations }
  end;

var
  SU1: TSU1;

implementation

{$R *.dfm}
uses _Buffers, _dos, ConstDef, _SqlUtills;

function TSU1.CreateSql():String ;
var
  sql, name, s2:	String;
  whereAdded:	Boolean;
begin
  if Count1.Checked then
    sql := ' select word, count(word) from log '
  else sql := ' select * from log ';
//add sql for showing right and wrong answers
  whereAdded := True;
   if ShowRightWords.Checked
    and not ShowWrongWords.Checked
    then sql := sql + ' where ANSWER IS NULL '
   else if not ShowRightWords.Checked
    and ShowWrongWords.Checked
    then sql := sql + ' where ANSWER IS NOT NULL '
   else if ShowRightWords.Checked
    and ShowWrongWords.Checked
    then whereAdded := False //sql := sql + 'where ANSWER IS NOT NULL'
   else if not ShowRightWords.Checked
    and not ShowWrongWords.Checked
    then sql := sql + ' where ANSWER <> ANSWER ';
// add sql for whitch user to show
   if ShowCurrentUser.Checked then
    begin
      name := pas.User;
      if name = '' then
	begin
	  ShowMessage('No valid user name');
	  ModalResult := mrCancel;
	  result := '';
	end;
    end
   else if PickFromList.Checked then name := UserList.Text
   else name := '';
   if name <> '' then
    begin
       if whereAdded then sql := sql + ' and name = '
       else sql := sql + ' where name = ';
      AddSqlQuote(sql, name);
      whereAdded := True;
    end;
//date checking code.
   if FromDate.Checked then
    begin
      name := '';
      s2 := '';
      AddSqlQuote(name, UnCodeDate(FromDate.Date - 1));
      AddSqlQuote(s2, UnCodeDate(ToDate.Date));
       if whereAdded then
	begin
	  sql := sql + ' and cdate(date1,'+ name + ') = 1 ';
	  if ToDate.Checked then
	    sql := sql + ' and cdate(date1,'+ s2 + ') <> 1 ';
	end
	else begin
	  sql := sql + ' where cdate(date1,'+ name + ') = 1 ';
	  if ToDate.Checked then
	    sql := sql + ' and cdate(date1,'+ s2 + ') <> 1 ';
	end;
    end;
  if Count1.Checked then
  begin
    sql := sql + ' group by word';
    if countg.Enabled and CountG.Checked then
      sql := sql + ' having count(word) > ' + IntToStr(SpinEdit1.Value);
    if CountL.Checked then
      sql := sql + ' and count(word) < ' + IntToStr(SpinEdit2.Value);
    sql := sql + ' order by 2 desc';
  end;
  result := sql;
end;

procedure TSU1.BitBtn1Click(Sender: TObject);
var
  s, s2,u:	string;
  buf:BufferO;
begin
//  inherited;
  s := InputBox('New File', 'Input a file name', '');
  s := fileName(s);
  u := fileName(UserList.Text);
   if s = '' then exit;
  s2 := RootDir+u+'.spl\'+s+'.Spl';
  if not TestDir(FilePath(s2)) then CreateDir(s2);
   if test(s2) then
    MessageDlg('File already exists', mtWarning, [mbOk],0)
   else if MessageDlg('Send SQL output to: ' + u +'\'+s,
	mtConfirmation, [mbYes, mbNo],0) = mrYes then
    begin
       if TestOpen(s2) then
	begin
	  buf := bufferO.Create;
	  buf.add('"'+pas.User+'"');
	  SaveBuffer(buf,FilePath(s2)+FileName(s2)+'.usr');
	  buf.Destroy;
	  Label4.Caption := u + '.spl\'+ FileName(s2);
	end;
    end;

end;

procedure TSU1.BitBtn2Click(Sender: TObject);
var
  s, f2:	string;
  buf:BufferO;
  r: Integer;
begin
//  inherited;
  f2 := RootDir + Label4.Caption;
  if DBGrid1.DataSource.DataSet.RecordCount > 0 then
  begin
    buf := bufferO.Create;;
    DBGrid1.DataSource.DataSet.First;
    while not DBGrid1.DataSource.DataSet.Eof do
    begin
      s := DBGrid1.DataSource.DataSet.FieldValues['word'];
      buf.Add(s);
      DBGrid1.DataSource.DataSet.Next;
    end;
    if not TestDir(FilePath(f2)) then CreateDir(f2);
    r := SaveBuffer(buf,FilePath(f2)+FileName(f2)+'.spl');
    if r = 0 then
      MessageDlg(IntToStr(buf.Len) + ' words successfully writen to file', mtInformation, [mbOk],0)
    else
      MessageDlg('Error '+ IntToStr(r) +' writing to file', mtError, [mbOk],0);
    buf.Destroy;
  end;

end;

procedure TSU1.updateUserList(Sender: TObject);
begin
  inherited;
  Label4.Caption := fileName(UserList.Text) + '.spl\WrongWords.Spl'
end;

procedure TSU1.CountGClick(Sender: TObject);
begin
  if countG.Checked then
    SpinEdit1.Enabled := True
  else
    SpinEdit1.Enabled := False;
  UpDateSql;
end;

procedure TSU1.CountClick(Sender: TObject);
begin
  if count1.Checked then
  begin
    if countG.Checked then SpinEdit1.Enabled := True
    else SpinEdit1.Enabled := False;
    if countL.Checked then SpinEdit2.Enabled := True
    else SpinEdit2.Enabled := False;
    CountG.Enabled := True;
    CountL.Enabled := True;
  end
  else begin
    SpinEdit1.Enabled := False;
    SpinEdit2.Enabled := False;
    CountG.Enabled := False;
    CountL.Enabled := False;
  end;
  UpDateSql;
end;

procedure TSU1.CountLClick(Sender: TObject);
begin
  if countL.Checked then
    SpinEdit2.Enabled := True
  else
    SpinEdit2.Enabled := False;
  UpDateSql;
end;

procedure TSU1.SpinEdit1Change(Sender: TObject);
begin
  UpDateSql;
end;

procedure TSU1.ShowCurrentUserClick(Sender: TObject);
begin
  inherited;
  Label4.Caption := fileName(UserList.Text) + '.spl\WrongWords.Spl'
end;

procedure TSU1.ShowAllUserClick(Sender: TObject);
begin
  inherited;
  Label4.Caption := 'WrongWords.Spl'
end;

procedure TSU1.PickFromListClick(Sender: TObject);
begin
  inherited;
  Label4.Caption := fileName(UserList.Text) + '.spl\WrongWords.Spl'
end;

procedure TSU1.UserListChange(Sender: TObject);
begin
  inherited;
  Label4.Caption := fileName(UserList.Text) + '.spl\WrongWords.Spl'
end;

end.
