unit _ViewConpiled;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, _Buffers, _Math, Menus, _Script, Buttons;

type
  TCompiledView = class(TForm)
    RichEdit1: TRichEdit;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Print1: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    BitBtn1: TBitBtn;
    procedure N1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
  private
    { Private declarations }
    buf: BufferO;
    Procedure AddLine(s:string;color:TColor;style:TFontStyles);
    Procedure AddText(s:string; color:TColor; Style:TFontStyles);
    Procedure SetLastStyle(n:word; color:TColor; Style:TFontStyles);
  public
    { Public declarations }
    Procedure ViewBuf1(buf:BufferO);
    Procedure View(f:string);
  end;

var
  CompiledView: TCompiledView;

implementation
uses
  _String;

{$R *.dfm}

Procedure TCompiledView.View(f:string);
begin
  buf := bufferO.Create;
  LoadBuffer(buf, f{EditFile});
  ViewBuf1(buf);
  CompiledView.ShowModal;
  buf.Destroy;
end;

Procedure TCompiledView.AddText(s:string; color:TColor; Style:TFontStyles);
begin // there are problems with this
  RichEdit1.SelStart :=  RichEdit1.GetTextLen;
  richEdit1.SelLength := 0;
  RichEdit1.SelAttributes.Color := color;
  RichEdit1.SelAttributes.Style := Style;//[fsStrikeOut];
  RichEdit1.SelText := s;
end;

Procedure TCompiledView.AddLine(s:string;color:TColor;style:TFontStyles);
begin
  RichEdit1.SelStart :=  RichEdit1.GetTextLen;
  richEdit1.SelLength := 0;
  RichEdit1.SelAttributes.Color := color;
  RichEdit1.SelAttributes.Style := style;
  RichEdit1.Lines.Add(s);
end;

Procedure TCompiledView.SetLastStyle(n:word; color:TColor; Style:TFontStyles);
begin
  n:=n+2;//#10#13 ???
  RichEdit1.SelStart :=  RichEdit1.GetTextLen-n;
  richEdit1.SelLength := n;
  RichEdit1.SelAttributes.Color := color;
  RichEdit1.SelAttributes.Style := style;
end;

Procedure TCompiledView.ViewBuf1(buf:BufferO);
var
  x,y,n : Integer;
  t,t2:string;
  buf2: BufferO;
  dP: word;
  rE: Boolean;
begin
  buf2 := bufferO.Create;
  dp := decimalPoints;
  rE := RandomizeExpand;
  RichEdit1.Lines.Clear;
   for x := 1 to buf.len do
    begin
      t := buf.Get(x);
      if (not UpdateSwitch(t)) and (ScriptOverride)then
      begin
	expandNumber(buf2,t);
	addAnswersNumber(buf2);
	if buf2.Len > 0 then
	begin
	  if (buf2.Len = 1) and (buf2.Get(1) = t) then
	  begin
	    AddLine(t,clPurple,[]);
	  end
	  else begin
	    AddLine(t,clBlue,[]);
	    n := InStrPosS(t,'//') -1;
	    if n > 0 then
	    begin
	      SetLastStyle(length(t) - n, clBlack,[fsStrikeOut]);
{	      t2 := SplitS1(t,'//');
	      AddLine(t2, clBlue,[]);
	      AddText(t, clBlack,[fsStrikeOut]);
	    end
	    else begin
	      AddLine(t,clBlue,[]);}
	    end;
	    for y := 1 to buf2.Len do
	      begin
		AddLine(buf2.Get(y),clGreen,[fsItalic]);
	      end;
	  end;
	  buf2.Clr;
	end
	else begin
	  AddLine(t,clBlack,[fsStrikeOut]);
	end;
      end
      else begin
	AddLine(t,clBlack,[fsBold]);
      end;
    end;
  decimalPoints := dP;
  RandomizeExpand := rE;
  buf2.Destroy;
end;


procedure TCompiledView.N1Click(Sender: TObject);
begin
  self.ModalResult := mrOk;
end;

procedure TCompiledView.BitBtn1Click(Sender: TObject);
begin
  CompiledView.Visible := false;
  ViewBuf1(buf);
  CompiledView.Visible := true;
end;

end.
