unit input;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ConstDef, Buttons, _WrongWords, _Script;

type
  T_Input = class(TForm)
    Edit1: TEdit;
    Replay: TButton;
    BReShow: TButton;
    Progress: TLabel;
    BitBtn1: TBitBtn;
    procedure FormResize(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure BReShowClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ReplayClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Procedure Mane2(f, name :String);

const
  minD		= 500;		// min time to display word
  letD		= 75;		// add this much for each letter
  d 		= 2;
  pauseD	= 1500;		// Wait this long before allowed to enter word
//  CurrentFile: string ='d:\spl6\joseph\spl.spl\f1.spl';
var
  _Input: T_Input;

//  CurrentFile: string;

implementation

uses _Message, _String, _Buffers, _Dos, _Code, Option, {_ScoreUtils}
	_ScoreUtils2, soundDB, Score2, _Math, _Edit, MathInput;

var
  helpDepth	:Word;
  cQ {current Question}, cA{current answer}     :String;

{$R *.DFM}

Function MakeRanOrderFile(f2 : ComStr; fileSize:Word): Boolean;
var
  buf{, wordBuf}:		BufferO;
  x, bL, z, y:	Word;
begin
  buf := bufferO.Create;
   if fileSize < 1 then
    begin
      MessageDlg(' Not enough words in file',
		    mtError, [mbOK],0);
      MakeRanOrderFile := False;
      buf.Destroy;
      Exit;
    end;
   for x := 1 to fileSize do buf.add(IntToStr(x));
  Randomize;
//  write('Please waite while I randomize the order of sequence file');
  bL := buf.len{ - x2};
   if not inOrder then
    begin
       for y := 1 to 5 do
       for x := 1 to buf.Len do
	begin
	  z := Random(bL) + 1;
	  buf.swop(x, z);
	end;
    end;
   if not TestDir(FilePath(f2)) then CreateDir(f2);
  SaveBuffer(buf, f2);
  MakeRanOrderFile := True;
  buf.Destroy;
end;


Function Format(var buf : BufferO; mult: Boolean):Boolean;
var
  x : Word;
  s:	String;
begin
  Format := True;
  x := 1;
   while x <= buf.Len do
    begin
{$B-}
      s := buf.get(x);
      if (Length(s) >= 1) then
	begin
	  if s[1] = ' ' then
	    begin
	      Format := False;
	      s := DelLeading(s, ' ');
	      buf.Ovr(s, x);
	    end;
	  if (s[length(s)] = ' ') then
	    begin
	      Format := False;
	      s := DelTrailing(s, ' ');
	      buf.Ovr(s, x);
	    end;
	 end;
       if s = '' then
	begin
	  Format := False;
	  buf.del(x);
	end
       else if not mult then
       begin
	 if  buf.InBufCountBefore(s, x-1) = 0 then Inc(x)
	 else begin
	   Format := False;
	   buf.del(x);
	 end;
       end
       else Inc(x);
    end;
end;

procedure expandScript(var buf: BufferO);
var
  x,c,errorCount: word;
  s,t: String;
  bufExpand, bufOut: BufferO;
  REOld:Boolean;
  decimalPointsOld:Integer;
begin
  errorCount := 0;
  bufExpand := bufferO.Create;
  bufOut := bufferO.Create;
  REOld := RandomizeExpand;
  ScriptOverride := False;
  decimalPointsOld := decimalPoints;
  x:= 1;
  while x <= buf.Len do
  begin
    s := buf.get(x);
    if IsSwitch(s) then UpdateSwitch(s)
    else if ScriptOverride then
    begin //first check for spellings
      if (length(s) > 1) and not((s[1] = '$') or (s[1] = '/')) then bufOut.Add(s)
      else if length(s) <= 1 then
      begin
	if (length(s) = 1) and not (s[1] = '$') then bufOut.Add(s);
      end
      else if not ((s[1] = '/') and (s[2] = '/'))
	      and not (s[1]= '$') then bufOut.Add(s)
      else if s[1] = '$' then//length has to be at least 2 at this point
      begin
	bufExpand.Clr;
	expandNumber(bufExpand, s);
	addAnswersNumber(bufExpand);
	for c := 1 to bufExpand.Len do
	begin
	  t := bufExpand.Get(c);
	  if (length(t) > 1)
	  and not ((t[1] = '/') and (t[2] = '/'))
	  then bufOut.Add(t)
	  else inc(errorCount);
	end;
      end;
    end
    else bufOut.Add(s);
    inc(x);
  end;
  if errorCount > 0 then MessageDlg(' There are '+IntToStr(errorCount)+' Errors in the spelling file please check it! The error count is only aproximate and will count expanded lines and/or sometime only the first error etc.',
			   mtWarning, [mbOK],0);
  RandomizeExpand := REOld;
  decimalPoints := decimalPointsOld;
  bufExpand.Destroy;
  buf.Destroy;
  buf := bufOut;
end;

Function CheckAns(qA, Innput:string;var t:Integer):Boolean;
begin
  result := False;
  if (qA <> innput) and (cA <> cQ) then
  begin
    if IsReal(cA) or (InString(cA,DecimalSeparator) and IsDec(cA)) then
    begin
      if StrToFloat(cA) = StrToFloat(innput) then result := True;
    end;
  end;
  if not result then result := qA = innput;
  if result then
   begin
     Message(' Message ', 'RIGHT !!',clLime, d * 500,  0, 0);
   end else
   begin
     t := t + 1;
     SoundFor(400, 1000);
     if cA = cQ then WrongWords(innput, cA)
     else WrongWords(innput, cA)
   end;
end;

Procedure Mane2(f : String; name :String);
var
  x, bufIn, words:		Word;
  t, nextLogGroup:		Integer;
  innput, psf, logEntery:	String;
  error,helpDepthG, totellHelp:	Word;
  wordBuf, buf, bufDel:		BufferO;
  r:				scoreR;
  inOrderTemp:                  Boolean;
  label repy, Quit;

  Procedure GetNextWord;
  begin
    if inOrder then
      begin
	cA := wordBuf.Get(x);
      end
      else begin
	if buf.Len > 0 then bufIn := StrToNum(buf.get(1));
	if (buf.len < 1) or (bufIn > buf.len) then
	  begin
	    MakeRanOrderFile(psf, wordBuf.Len);
	    error := LoadBuffer(Buf, psf);
	    if error <> 0 then
	      begin
		MessageDlg(' Error loading buffer '+ ErrorCode(error),
		mtError, [mbOK],0);
		buf.Clr;
		wordBuf.Clr;
		Exit;
	      end;
	    bufIn := StrToNum(buf.get(1));
	  end;
	cA := wordBuf.Get(bufIn);
	buf.del(1);
      end;
    if inString(cA,'|') then
      begin
	cQ := SplitK2(cA,'|');
      end
    else cQ := cA
  end;

begin
  wordBuf := bufferO.Create;
  f := SUpCase(f);
  helpDepthG := 0;
  totellHelp := 0;
//  wordBuf.Done;
  psf := ProgramDir+UserSubDir+ FileName(name)+'.DIR\'+SubDir+FileName(f)+'.POS';
   if FileExt(f) = '.NAM' then psf := FilePath(f)+FileName(f)+'.PO2';
  error := LoadBuffer(wordBuf, f);
   if error <> 0 then
    begin
      MessageDlg(' Error loading buffer <'+f+'>'#10
      + ErrorCode(error),mtError, [mbOk], 0);
      wordBuf.Destroy;
      Exit;
    end;
  buf := bufferO.Create;
  bufDel := bufferO.Create;
  if (wordBuf.Find('$noSort',7, false) > 0) then noSortOverride := True
  else noSortOverride := False;
  if not Format(wordBuf, SUpCase(FileExt(f)) = '.NAM')
  then SaveBuffer(wordBuf, f);
  expandScript(wordBuf);
  if not noSortOverride then wordbuf.sort;
  inOrderTemp := inOrder;
  if noSortOverride then inOrder := true;
//  EditSpl.ViewBuf(Wordbuf);
  t := 0;
  innput := '';
  if (doFile) and (not inOrder) then MakeRanOrderFile(psf, wordBuf.Len);
  if doFile then words := wordBuf.len else words := 10;
  if (not doFile) or (not inOrder) then
    begin
       if test(psf) then
	begin
	   if LoadBuffer(Buf, psf) <> 0 then
	     MakeRanOrderFile(psf, wordBuf.Len)
	   else if inOrder then buf.SortNumeric;
	end;
    end;
  nextLogGroup := su.GetNextLogGroup;
   for x := 1 to words do
    begin
      GetNextWord;
repy:
      if cA = cQ then
	begin
	  if SoundsForm.WavForWord(cA) then
	    begin
	      SoundsForm.PlayWord(cA);
	    end;
	  Message('Word to enter', cQ,clAqua, MinD+(Length(cQ) * LetD), 1000,pauseD);
	end
	else begin
	  if SoundsForm.WavForWord(cQ) then
	    begin
	      SoundsForm.PlayWord(cQ);
	    end;
	end;
      _Input.Progress.Caption := 'Hi score '+IntToStr(words - t)+' : '+
			    IntToStr(words - x)+' go''''s left out of '+
			    IntToStr(words)+' words';
      helpDepth := 0;
	repeat
	  if cA = cQ then
	    begin
	      _Input.Edit1.Text := '';
	      _input.HelpContext := 0;
	      _Input.ShowModal;
	      innput := _Input.Edit1.Text;
	    end
	    else begin
	      innput := MathDialog(cQ,IntToStr(decimalPoints)
			  ,'Hi score '+IntToStr(words - t)+' : '+
			    IntToStr(words - x)+' go''''s left out of '+
			    IntToStr(words)+' words')
	    end;
	until innput <>  '';
       if helpDepth > helpDepthG then helpDepthG := helpDepth;
      totellHelp := totellHelp + helpDepth;

       if innput = 'exit' then
	begin
	  if cA = cQ then
	    begin
	      _Input.Edit1.Text := 'Please type in the last word';
	      _input.HelpContext := 0;
	      _Input.ShowModal;
	      innput := _Input.Edit1.Text;
	    end
	    else begin
	      innput := '';
	      InputQuery('Type in the ansswer', cQ, innput);
	    end;
	   if helpDepth > helpDepthG then helpDepthG := helpDepth;
	  totellHelp := totellHelp + helpDepth;
//	  helpDepth := 0;
	  if cA=cQ then logEntery := cQ
	  else logEntery := cQ+'|'+cA;
	   if not CheckAns(cA, Innput,t) then AddLog(name, f, logEntery, Innput, nextLogGroup, helpDepth)
	   else if logAll then AddLog(name, f, logEntery, logEntery, nextLogGroup, helpDepth);
	  r.name	:= name;
	  r.score	:= x - t;	{debug}
	  r.maxHelp	:= helpDepthG;
	  r.tolalHelp	:= totellHelp;
	  r.total	:= x;
	  AddScore(f, r, nextLogGroup);
//	  loadBufFromScoreDB(subDir+FileName(f)+'.SCO',True);
	  sf2.logGroupId := nextLogGroup;
	  sf2.ShowModal;
	  Goto Quit;
	end;
       if cA=cQ then logEntery := cQ
       else logEntery := cQ+'|'+cA;
       if not CheckAns(cA, Innput,t) then
	begin
	  AddLog(name, f, logEntery, Innput, nextLogGroup, helpDepth);
	  goto repy;
	end
	else if logAll then AddLog(name, f, logEntery, logEntery, nextLogGroup, helpDepth);
    end;
  r.name	:=name;
  r.score	:=words -t;
  r.maxHelp	:=helpDepthG;
  r.tolalHelp	:=totellHelp;
  r.total	:=words;
  AddScore(f, r, nextLogGroup);
//  loadBufFromScoreDB(subDir+FileName(f)+'.SCO', True);
  sf2.logGroupId := nextLogGroup;
  sf2.ShowModal;
Quit:
   inOrder := inordertemp;
   if buf.Len < 1 then
    begin
      if test(psf) then DeleteFile(psf);
    end
   else SaveBuffer(buf,psf);
  wordBuf.Destroy;
  buf.Destroy;
  bufDel.Destroy;
end;


procedure T_Input.FormResize(Sender: TObject);
begin
  ClientWidth := 340;
  ClientHeight := 95;
end;

procedure T_Input.Button2Click(Sender: TObject);
begin
  ModalResult := mrOk
end;

procedure T_Input.BReShowClick(Sender: TObject);
begin
   Inc(helpDepth);
   Message('Word to enter', cA,clAqua, MinD+(Length(cA) * LetD), 1000, PauseD);
  edit1.SetFocus;
end;

procedure T_Input.FormShow(Sender: TObject);
begin
  edit1.SetFocus;
  edit1.SelectAll;
  BReShow.Enabled := ReshowIfWave;
end;

procedure T_Input.ReplayClick(Sender: TObject);
begin
  edit1.SetFocus;
   if SoundsForm.WavForWord(cQ) then SoundsForm.PlayWord(cA);
end;

end.
